VERSION 5.00
Object = "{42D59A35-B688-11D5-ADA7-009027BF5C2D}#1.0#0"; "X-SubCls.ocx"
Object = "{C8563D4E-B688-11D5-ADA7-009027BF5C2D}#1.0#0"; "X-Hooks.ocx"
Begin VB.UserControl MenuBar 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   660
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ClipControls    =   0   'False
   DrawMode        =   11  'Not Xor Pen
   EditAtDesignTime=   -1  'True
   FillStyle       =   0  'Solid
   FontTransparent =   0   'False
   HasDC           =   0   'False
   ScaleHeight     =   44
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "Controls - MenuBar.ctx":0000
   Begin Hooking.HookHandler Hooks 
      Left            =   4200
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
   End
   Begin SubClassing.EventHandler EventHandler 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
   End
End
Attribute VB_Name = "MenuBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "Member0" ,"MenuBarItems"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

'==================================================================
'
' Menubar Control Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================



'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const DISALLOW_CUSTOMIZEPROP = True

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?

'------------------------------------------------------------------------
' Declarations

Private CurMenuLevel As Long
Private CurActiveMenuIndex As Long
Private CurActivehMenus() As OLE_HANDLE
Private CurSelectedhMenu As OLE_HANDLE
Private CurSelectedID As Long
Private CurTSelOpensMenu As Boolean
Private CurLastParent As OLE_HANDLE
Private CurhLastMenu As OLE_HANDLE



'-----------------------------------------------------------
' Current Properties

Private CurhWnd As Long
#If (WIN32_IE >= IE4) Then
  Private CurUseCustomColors As Boolean
  Private CurMenuHighlight As OLE_COLOR
  Private CurMenuShadow As OLE_COLOR
#End If
Private MB_Menus As MenuBarMenus
Private CurResizing As Boolean
Private CurSmartResize As Boolean
Private CurRunMode As Boolean

Private CurMenuChangeByKey As Boolean

Public Enum MbrActionSource
  mbrFromMenu = 0
  mbrFromAccelerator = 1
  mbrFromUnknown = -1
End Enum


'-----------------------------------------------------------
' Events

Public Event Click(ByVal Button As TbrButtonIndex)
Attribute Click.VB_Description = "Occured when the user clicks on th3e menubar."
Public Event DblClick(ByVal Button As TbrButtonIndex)
Attribute DblClick.VB_Description = "Occurs when the user double-clicks on the menubar."
Public Event HitEnter()
Attribute HitEnter.VB_Description = "Occures when the user hits enter."
Public Event MenuBarGotFocus()
Attribute MenuBarGotFocus.VB_Description = "Occures when the menubar itself gets the focus."
Public Event MenuBarLostFocus()
Attribute MenuBarLostFocus.VB_Description = "Occures when the menubar itself loses the focus."
Public Event MouseMove()
Attribute MouseMove.VB_Description = "Occures when the user moves the mouse above a menu item."

Public Event MenuClick(ByVal Menu As CoolBars.MenuBarMenu, ByVal Source As MbrActionSource)
Public Event MenuDragInitialize(ByVal Menu As MenuBarMenu)
Public Event MenuDragTerminate(ByVal Menu As MenuBarMenu)
Attribute MenuDragTerminate.VB_Description = "Occures when the user is finished dragging buttons."
Public Event CustomizeInitialize(ByVal Menu As MenuBarMenu)
Attribute CustomizeInitialize.VB_MemberFlags = "40"
Public Event CustomizeTerminate(ByVal Menu As MenuBarMenu)
Attribute CustomizeTerminate.VB_MemberFlags = "40"
Public Event CustomizeShowDlg(ByRef ShowHelp As Boolean)
Attribute CustomizeShowDlg.VB_MemberFlags = "40"
Public Event CustomizeQueryInsert(ByVal NewMenuIndex As Long, ByRef Allow As Boolean)
Attribute CustomizeQueryInsert.VB_MemberFlags = "40"
Public Event CustomizeQueryDelete(ByVal Menu As MenuBarMenu, ByRef Allow As Boolean)
Attribute CustomizeQueryDelete.VB_MemberFlags = "40"
Public Event CustomizeHelp()
Attribute CustomizeHelp.VB_Description = "Occures when the user presses the help button in the customize dialog box."
Attribute CustomizeHelp.VB_MemberFlags = "40"
Public Event CustomizeReset()
Attribute CustomizeReset.VB_Description = "Occures when the menubar is expected to be restored in the original state."
Attribute CustomizeReset.VB_MemberFlags = "40"
Public Event Change()
Attribute Change.VB_Description = "Occures when the menubar has changed."
Public Event SaveSettings()
Public Event RestoreSettings()
Public Event MenuDragOut(ByVal Menu As MenuBarMenu)
Attribute MenuDragOut.VB_Description = "Occures when a menu is dragged out of the menubar."
Public Event MenuDeleting(ByVal Menu As MenuBarMenu)
Attribute MenuDeleting.VB_Description = "Occures when a menubar button is about to be deleted."
#If (WIN32_IE >= IE4) Then
  Public Event HotItemChange(ByVal OldMenu As MenuBarMenu, ByVal NewMenu As MenuBarMenu, ByVal Flags As TbrHotItemChangeFlags, ByRef Allow As Boolean)
Attribute HotItemChange.VB_Description = "Occures when a different menubar button is selected."
  Public Event NeedMenuInfo(ByVal Menu As MenuBarMenu, ByVal Requested As TbrRequestType, ByRef Text As String, ByRef ImageIndex As Long, ByRef KeepAsking As Boolean)
Attribute NeedMenuInfo.VB_Description = "Requests menu button info."
  Public Event ReleaseCapture()
Attribute ReleaseCapture.VB_Description = "Occures when the user released mouse capture."
#End If

Public Event MenuItemClick(ByVal MenuItem As PopupMenus.MenuItem, ByVal Source As MbrActionSource)
Public Event ShowContextMenu(ByVal hWndOn As OLE_HANDLE, ByVal MouseX As Integer, ByVal MouseY As Integer)
Attribute ShowContextMenu.VB_Description = "Occures when windows thinks a context menu is required when the user right-clicks on a window."

Public Event DrawMenuItem(ByVal Menu As PopupMenus.MenuContainer, ByVal MenuItem As PopupMenus.MenuItem, ByVal ItemX1 As Long, ByVal ItemY1 As Long, ByVal ItemX2 As Long, ByVal ItemY2 As Long, ByVal DrawMethod As PopupMenus.MenuDrawItemMethod, ByVal ItemState As PopupMenus.MenuDrawItemStates, ByVal hDCItem As Long, ByVal hWndItem As Long, ByRef Handled As Boolean)
Public Event MeasureMenuItem(ByVal MenuItem As PopupMenus.MenuItem, ByRef ItemWidth As Long, ByRef ItemHeight As Long)

Public Event EnterMenuLoop(ByVal ByPopupMethod As Boolean, ByRef Processed As Boolean)
Attribute EnterMenuLoop.VB_Description = "Occures when the user is about to walk through the menu."
Public Event ExitMenuLoop(ByVal ByPopupMethod As Boolean, ByRef Processed As Boolean)
Attribute ExitMenuLoop.VB_Description = "Occures when the user is finished walking through a menu."

Public Event InitMenu(ByVal Menu As PopupMenus.MenuContainer, ByRef Processed As Boolean)
Public Event InitMenuPopup(ByVal Menu As PopupMenus.MenuContainer, ByVal ParentMenuItemIndex As Integer, ByVal IsWindowMenu As Boolean, ByRef Processed As Boolean)
Public Event UnInitMenuPopup(ByVal Menu As PopupMenus.MenuContainer, ByVal MenuItemID As Long)
Public Event SubMenuLevelChange(ByVal NewValue As Long)
Attribute SubMenuLevelChange.VB_Description = "Occures when the user walks through the popup menus, and enters/leaves a submenu."

Public Event MenuItemSelect(ByVal Menu As PopupMenus.MenuContainer, ByVal MenuItem As PopupMenus.MenuItem, ByVal ItemFlags As PopupMenus.MenuItemSelectFlags, ByRef Processed As Boolean)
Public Event MenuUnSelect()
Attribute MenuUnSelect.VB_Description = "Occures when a popup menu is unselected."

Public Event MenuItemFromChar(ByVal Menu As PopupMenus.MenuContainer, ByVal MenuType As PopupMenus.MenuContainerType, ByVal CharCode As Integer, ByRef MenuItemID As Integer, ByRef ReturnInfo As PopupMenus.MenuItemFromCharReturnValue)
Public Event MenuItemBeginDrag(ByVal Menu As PopupMenus.MenuContainer, ByVal StartIndex As Long, ByRef AllowDrag As Boolean)
Attribute MenuItemBeginDrag.VB_MemberFlags = "40"
Public Event MenuItemRButtonUp(ByVal Menu As PopupMenus.MenuContainer, ByVal MenuItem As PopupMenus.MenuItem)

Public Event MenuItemGetObject(ByVal Menu As PopupMenus.MenuContainer, ByVal MenuItem As PopupMenus.MenuItem, ByVal RequestInterface As Object, ByRef ReturnObject As Object, ByVal Flags As Long)



Private Sub EventHandler_ReceivedMessage(ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long, ReturnMessage As SubClassing.EventResultMessage)
  Dim I As Long
  Dim MenuContainer As PopupMenus.MenuContainer
  Dim MenuItem As PopupMenus.MenuItem
  Dim Text As String
  Dim Pt1 As POINTAPI
  Dim Size1 As RECT
  Dim Size2 As RECT
  Dim NMHDR As NMHDR
  Dim NMTBR As NMTOOLBAR
#If (WIN32_IE >= IE4) Then
  Dim NMHOTITEM As NMTBHOTITEM
  Dim NMDISPINFO As NMTBDISPINFO
#End If
  Dim NMSECRET As NMRB_SECRET
  Dim DWORD As DWORD
  Dim DWORD_N As DWORD_LONG
  Dim Allow As Boolean
  
  Dim MENUITEMINFO As MENUITEMINFO
  
  ReturnMessage = SubClassing.evtCallPrevWinProc
  
  Select Case WindowMessage
  
      ' MENUBAR MESSAGES!
    
    Case WM_COMMAND
        DWORD_N.N = wParam      ' LoWord = ID
        LSet DWORD = DWORD_N    ' HiWord = ActionSource
        If lParam = CurhWnd Then
          Dim Menu As MenuBarMenu
          Set Menu = ToolBar_GetItemFromID(CurhWnd, DWORD.LoWord)
          RaiseEvent MenuClick(Menu, CLng(DWORD.HiWord))
          ReturnMessage = SubClassing.evtHandled
          
          ' Now, let's show the submenu
          Call GetWindowRect(CurhWnd, Size1)
          Call SendMessage(CurhWnd, TB_GETITEMRECT, Menu.Index - 1, Size2)
          Pt1.X = Size1.Left + Size2.Left
          Pt1.Y = Size1.Top + Size2.Top
          CurActiveMenuIndex = Menu.Index
          Call SendMessage(CurhWnd, TB_SETHOTITEM, CurActiveMenuIndex - 1, ByVal 0)
          Menu.Pressed = True
          If DWORD.HiWord = mbrFromAccelerator Then
            ' Post keydown message into message stream, so first/last menu item is selected:
            Call PostMessage(UserControl.hWnd, WM_KEYDOWN, vbKeyDown, ByVal 1)
            Call PostMessage(UserControl.hWnd, WM_KEYUP, vbKeyDown, ByVal 1)
          End If
          
          
          Debug.Print Pt1.X, Pt1.Y, Size1.Left + Size2.Left, Size1.Top + Size2.Top, Size1.Left + Size2.Right - 1, Size1.Top + Size2.Bottom - 1
          Call Menu.SubMenu.PopupEx(UserControl.hWnd, , Pt1.X, Pt1.Y, 1, Size1.Top + Size2.Top, Screen.Width, Size1.Top + Size2.Bottom - 1)
          Call SendMessage(CurhWnd, TB_SETHOTITEM, -1, ByVal 0)
          CurActiveMenuIndex = 0
          Menu.Pressed = False
        ElseIf lParam = 0 Then    ' Properly menu command
          RaiseEvent MenuItemClick(MenuBar_GetMenuItemFromID(Me.Menus, DWORD.LoWord), CLng(DWORD.HiWord))
          ReturnMessage = SubClassing.evtHandled
        Else
          Debug.Print "WM_COMMAND for hwnd:=&H" & Hex(lParam)
        End If
#If (WIN32_IE >= IE4) Then
    Case WM_SYSCOLORCHANGE
        ' This need to be done when we set the color explicitly
        Me.MenuHighlightColor = Me.MenuHighlightColor
        Me.MenuShadowColor = Me.MenuShadowColor
        ReturnMessage = SubClassing.evtHandled
#End If
    Case WM_ERASEBKGND
        ' Required when your control is hosting the toolbar itsself
        If GetParent(CurhWnd) = UserControl.hWnd Then
          Dim hBrush As OLE_HANDLE
          Call GetClientRect(CurhWnd, Size1)
          hBrush = CreateSolidBrush(CoolBar_CColor(UserControl.BackColor))
          Call FillRect(wParam, Size1, hBrush)
          Call DeleteObject(hBrush)
        End If
    Case WM_GETMINMAXINFO
        ReturnMessage = EventHandler.CallWinProc(CurhWnd, WindowMessage, wParam, lParam)
      
      ' MENU MESSAGES!
    
    Case WM_MENUCOMMAND
        ' This message replaces WM_COMMAND
        DWORD_N.N = wParam      ' W95: wParam = Index
        LSet DWORD = DWORD_N    ' W98: LoWord = Index, HiWord = ID
        MENUITEMINFO.cbSize = LenB(MENUITEMINFO)
        MENUITEMINFO.fMask = MIIM_DATA
        If GetMenuItemInfo(lParam, DWORD.LoWord, True, MENUITEMINFO) = 0 Then Error 5
        RaiseEvent MenuItemClick(GetObjFromPtr(-MENUITEMINFO.dwItemData), mbrFromUnknown)
    Case WM_CONTEXTMENU
        DWORD_N.N = lParam
        LSet DWORD = DWORD_N
        RaiseEvent ShowContextMenu(wParam, DWORD.LoWord, DWORD.HiWord)
    Case WM_ENTERMENULOOP
        RaiseEvent EnterMenuLoop(CBool(wParam), Allow)
        If Allow Then ReturnMessage = SubClassing.evtHandled
    Case WM_EXITMENULOOP
        RaiseEvent ExitMenuLoop(CBool(wParam), Allow)
        If Allow Then ReturnMessage = SubClassing.evtHandled
    Case WM_INITMENU
        RaiseEvent InitMenu(MenuBar_GetMenu(wParam), Allow)
        If Allow Then ReturnMessage = SubClassing.evtHandled
        ' MENUBAR-EXTENTION: Is it one of our own top level menus?
        If CurMenuLevel = 0 Then
          For I = 0 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) - 1
            Set Menu = ToolBar_GetItem(CurhWnd, I)
            If Not Menu.SubMenu Is Nothing Then
              If Menu.SubMenu.hMenu = wParam Then
                CurMenuLevel = 1
                ReDim CurActivehMenus(0 To 0) As OLE_HANDLE
                CurActivehMenus(0) = wParam
                RaiseEvent SubMenuLevelChange(CurMenuLevel)
                MenuBar_MsgHooked = True
                CurActiveMenuIndex = I + 1
                Exit For
              End If
            End If
          Next
        End If
    Case WM_INITMENUPOPUP
        DWORD_N.N = lParam
        LSet DWORD = DWORD_N
        CurTSelOpensMenu = CBool(DWORD.LoWord)
        RaiseEvent InitMenuPopup(MenuBar_GetMenu(wParam), DWORD.LoWord, CBool(DWORD.HiWord), Allow)
        If Allow Then ReturnMessage = SubClassing.evtHandled
        ' MENUBAR-EXTENTION: Is it one of our own menus?
        If CurMenuLevel Then
          If GetSubMenu(CurActivehMenus(CurMenuLevel - 1), CLng(DWORD.LoWord)) = wParam Then
            CurMenuLevel = CurMenuLevel + 1
            ReDim Preserve CurActivehMenus(0 To CurMenuLevel - 1) As OLE_HANDLE
            CurActivehMenus(CurMenuLevel - 1) = wParam
            RaiseEvent SubMenuLevelChange(CurMenuLevel)
          End If
        End If
    Case WM_UNINITMENUPOPUP
        RaiseEvent UnInitMenuPopup(MenuBar_GetMenu(wParam), lParam)
        If Allow Then ReturnMessage = SubClassing.evtHandled
        ' MENUBAR-EXTENTION: Is it the current popup menu collapsing?
        If CurActivehMenus(CurMenuLevel - 1) = wParam Then
          CurMenuLevel = CurMenuLevel - 1
          If CurMenuLevel = 0 Then
            MenuBar_MsgHooked = False
            Erase CurActivehMenus
            CurActiveMenuIndex = 0 ' VERY IMPORTANT! - ALT button toggle problems
            CurTSelOpensMenu = False
          Else
            ReDim Preserve CurActivehMenus(0 To CurMenuLevel - 1) As OLE_HANDLE
          End If
          RaiseEvent SubMenuLevelChange(CurMenuLevel)
        End If
    Case WM_MENUSELECT
        DWORD_N.N = wParam
        LSet DWORD = DWORD_N
        If DWORD.HiWord = &HFFFF And lParam = 0 Then
          RaiseEvent MenuUnSelect
          CurSelectedhMenu = 0
          CurSelectedID = 0
          CurTSelOpensMenu = False
        Else
          If lParam <> 0 Then
            Set MenuContainer = MenuBar_GetMenu(lParam)
            CurSelectedhMenu = lParam           ' MENUBAR-EXTENTION: Make Big Brother reality; follow the user
            If GetSubMenu(lParam, DWORD.LoWord) <> 0 Then
              Set MenuItem = MenuContainer.Menus(DWORD.LoWord, mnuItemByPosition)
              CurSelectedID = CLng(MenuItem.ID) ' MENUBAR-EXTENTION
              CurTSelOpensMenu = True
            Else
              Set MenuItem = MenuContainer.Menus(DWORD.LoWord, mnuItemByID)
              CurSelectedID = CLng(DWORD.LoWord) ' MENUBAR-EXTENTION
              CurTSelOpensMenu = False
            End If
          End If
          RaiseEvent MenuItemSelect(MenuContainer, MenuItem, CLng(DWORD.HiWord), Allow)
          If Allow Then ReturnMessage = SubClassing.evtHandled
        End If
    Case WM_DRAWITEM
        If wParam = 0 Then ' Control ID 0: Send by menu!
          Dim DRAWITEMSTRUCT As DRAWITEMSTRUCT
          Call CopyMemory(DRAWITEMSTRUCT, ByVal lParam, LenB(DRAWITEMSTRUCT))
          If DRAWITEMSTRUCT.CtlType = mnuDrawCtlMenu Then ' 2nd confirmation, DIS.CtlID is properly 0 too!
            Set MenuItem = GetObjFromPtr(-DRAWITEMSTRUCT.ItemData)
            Set MenuContainer = MenuItem.ParentMenu
            RaiseEvent DrawMenuItem(MenuContainer, MenuItem, DRAWITEMSTRUCT.rcItem.Left, DRAWITEMSTRUCT.rcItem.Top, DRAWITEMSTRUCT.rcItem.Right, DRAWITEMSTRUCT.rcItem.Bottom, DRAWITEMSTRUCT.ItemAction, DRAWITEMSTRUCT.ItemState, DRAWITEMSTRUCT.hDC, DRAWITEMSTRUCT.hWndItem, Allow)
            If Not Allow Then Call PopupMenus.MenuPopup_DrawItem(MenuContainer, MenuItem, DRAWITEMSTRUCT.rcItem.Left, DRAWITEMSTRUCT.rcItem.Top, DRAWITEMSTRUCT.rcItem.Right, DRAWITEMSTRUCT.rcItem.Bottom, DRAWITEMSTRUCT.ItemAction, DRAWITEMSTRUCT.ItemState, DRAWITEMSTRUCT.hDC, DRAWITEMSTRUCT.hWndItem)
            ReturnMessage = 1 ' Confirm Handled
          End If
        End If
    Case WM_MEASUREITEM
        If wParam = 0 Then ' Control ID 0: Send by menu!
          Dim MEASUREITEMSTRUCT As MEASUREITEMSTRUCT
          Call CopyMemory(MEASUREITEMSTRUCT, ByVal lParam, LenB(MEASUREITEMSTRUCT))
          If MEASUREITEMSTRUCT.CtlType = mnuDrawCtlMenu Then ' 2nd confirmation, DIS.CtlID is properly 0 too!
            Set MenuItem = GetObjFromPtr(-MEASUREITEMSTRUCT.ItemData)
            LSet Pt1 = PopupMenus.MenuPopup_MeasureItem(MenuItem)
            MEASUREITEMSTRUCT.ItemWidth = Pt1.X
            MEASUREITEMSTRUCT.ItemHeight = Pt1.Y
            RaiseEvent MeasureMenuItem(MenuItem, MEASUREITEMSTRUCT.ItemWidth, MEASUREITEMSTRUCT.ItemHeight)
            Call CopyMemory(ByVal lParam, MEASUREITEMSTRUCT, LenB(MEASUREITEMSTRUCT))
            ReturnMessage = 1 ' Confirm Handled
          End If
        End If
    Case WM_MENUCHAR
        Dim MenuItemID As Integer
        Dim MenuRetVal As PopupMenus.MenuItemFromCharReturnValue
        DWORD_N.N = wParam
        LSet DWORD = DWORD_N
        RaiseEvent MenuItemFromChar(MenuBar_GetMenu(lParam), DWORD.HiWord, DWORD.LoWord, MenuItemID, MenuRetVal)
        DWORD.LoWord = MenuItemID
        DWORD.HiWord = CInt(MenuRetVal)
        LSet DWORD_N = DWORD
        ReturnMessage = DWORD_N.N
    Case WM_MENUDRAG
        RaiseEvent MenuItemBeginDrag(MenuBar_GetMenu(wParam), wParam, Allow)
        ReturnMessage = IIf(Allow, mnuDragContinue, mnuDragEndMenu)
    Case WM_MENUGETOBJECT
        Set MenuContainer = MenuBar_GetMenu(wParam)
        Dim MENUGETOBJECTINFO As PopupMenus.MENUGETOBJECTINFO
        Dim GetObjectObj As Object
        Call CopyMemory(MENUGETOBJECTINFO, ByVal lParam, LenB(MENUGETOBJECTINFO))
        RaiseEvent MenuItemGetObject(MenuContainer, MenuContainer.Menus(MENUGETOBJECTINFO.uPos + 1, mnuItemByPosition), GetObjFromPtr(MENUGETOBJECTINFO.riid), GetObjectObj, MENUGETOBJECTINFO.dwFlags)
        If Not GetObjectObj Is Nothing Then
          MENUGETOBJECTINFO.pvObj = ObjPtr(GetObjectObj)
          Call CopyMemory(ByVal lParam, MENUGETOBJECTINFO, LenB(MENUGETOBJECTINFO))
          ReturnMessage = mnuGetObjNoError
        Else
          ReturnMessage = mnuGetObjNoInterface
        End If
    Case WM_MENURBUTTONUP
        Set MenuContainer = MenuBar_GetMenu(lParam)
        RaiseEvent MenuItemRButtonUp(MenuContainer, MenuContainer.Menus(wParam + 1, mnuItemByPosition))
    Case WM_NEXTMENU
    Case WM_SYSCOMMAND
    Case WM_MDIREFRESHMENU
    Case WM_MDISETMENU
    Case WM_NOTIFY
      Call CopyMemory(NMHDR, ByVal lParam, Len(NMHDR))
      
      Select Case NMHDR.code
        ' SECRET REBAR NOTIFICATIONS!
        
        Case RbrSecretNotifications.RBN_CHILD_ATTACH
            Call CopyMemory(NMSECRET, ByVal lParam, Len(NMSECRET))
            If NMSECRET.hWndBandChild = CurhWnd Then UserControl.BackStyle = 0
        Case RbrSecretNotifications.RBN_CHILD_DETACH
          Call CopyMemory(NMSECRET, ByVal lParam, Len(NMSECRET))
          If NMSECRET.hWndBandChild = CurhWnd Then
            UserControl.BackStyle = 1
            Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, 0, 0, (SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_FRAMECHANGED Or SWP_NOOWNERZORDER Or SWP_SHOWWINDOW))
          End If
          
        ' COMMON NOTIFICATIONS!
        
        Case NM_CUSTOMDRAW:       Exit Sub
#If (WIN32_IE >= IE4) Then
        Case NM_NCHITTEST:        Exit Sub
        Case NM_KEYDOWN:          Exit Sub
        Case NM_SETCURSOR:        Exit Sub
        Case NM_CHAR:             Exit Sub
#End If
#If (WIN32_IE >= IE5) Then
        Case NM_LDOWN:            Exit Sub
        Case NM_RDOWN:            Exit Sub
#End If
        Case NM_OUTOFMEMORY:      Error 7
        Case NM_CLICK:            RaiseEvent Click(tbrButtonLeft)
        Case NM_RCLICK:           RaiseEvent Click(tbrButtonRight)
        Case NM_DBLCLK:           RaiseEvent DblClick(tbrButtonLeft)
        Case NM_RDBLCLK:          RaiseEvent DblClick(tbrButtonRight)
        Case NM_RETURN:           RaiseEvent HitEnter
        Case NM_SETFOCUS:         RaiseEvent MenuBarGotFocus
        Case NM_KILLFOCUS:        RaiseEvent MenuBarLostFocus
        Case NM_HOVER:            RaiseEvent MouseMove
#If (WIN32_IE >= IE4) Then
        Case NM_RELEASEDCAPTURE:  RaiseEvent ReleaseCapture
#End If
        
          ' TOOLBAR NOTIFICATIONS!
          
#If (WIN32_IE >= IE5) Then
        Case TBN_RESTORE, TBN_SAVE: Debug.Assert False
#End If
#If (WIN32_IE >= IE4) Then
        Case TBN_GETDISPINFO
          ReturnMessage = 0
          Call CopyMemory(NMDISPINFO, ByVal lParam, Len(NMDISPINFO))
          Allow = True
          RaiseEvent NeedMenuInfo(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMDISPINFO.idCommand), NMDISPINFO.dwMask, Text, I, Allow)
          If Not Allow Then NMDISPINFO.dwMask = NMDISPINFO.dwMask Or TBNF_DI_SETITEM
          If NMDISPINFO.dwMask And tbrNeedImage Then NMDISPINFO.iImage = I
          If NMDISPINFO.dwMask And tbrNeedText Then
            If Len(Text) > NMDISPINFO.cchText Then
              Text = Left(Text, NMDISPINFO.cchText)
            Else
              Text = Text & String(NMDISPINFO.cchText - Len(Text), 0)
            End If
            Text = StrConv(Text, vbFromUnicode)
            
            ' Now, let's change some characters in the memory block pointed by StrPtr(NMTBGETINFOTIP.pszText) again
            Call CopyMemory(ByVal NMDISPINFO.pszText, ByVal StrPtr(Text), LenB(Text))
          End If
          Call CopyMemory(ByVal lParam, NMDISPINFO, LenB(NMDISPINFO))
#End If
        Case TBN_GETBUTTONINFOA, TBN_GETBUTTONINFOW ' ???
          ReturnMessage = 0
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          If NMTBR.iItem < SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) Then
            Set Menu = ToolBar_GetItem(CurhWnd, NMTBR.iItem)
            If Not Menu.Available Then
              Text = String(NMTBR.cchText, 0)
              If Trim(Menu.Description) <> "" Then Mid(Text, 1, Len(Menu.Description)) = Left(Menu.Description, NMTBR.cchText - 1)
              If NMHDR.code = TBN_GETBUTTONINFOA Then Text = StrConv(Text, vbFromUnicode)
              Call CopyMemory(ByVal NMTBR.pszText, ByVal StrPtr(Text), LenB(Text))
              ReturnMessage = 1
            End If
          End If
        Case TBN_BEGINDRAG
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          RaiseEvent MenuDragInitialize(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem))
        Case TBN_ENDDRAG
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          RaiseEvent MenuDragTerminate(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem))
        Case TBN_BEGINADJUST
          If NMHDR.IdFrom Then Set Menu = ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHDR.IdFrom)
          RaiseEvent CustomizeInitialize(Menu)
        Case TBN_ENDADJUST
          If NMHDR.IdFrom Then Set Menu = ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHDR.IdFrom)
          RaiseEvent CustomizeTerminate(Menu)
        Case TBN_RESET
          RaiseEvent CustomizeReset
        Case TBN_QUERYINSERT
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          Allow = True
          RaiseEvent CustomizeQueryInsert(NMTBR.iItem, Allow)
          ReturnMessage = IIf(Allow, 1, 0)
        Case TBN_QUERYDELETE
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          If NMTBR.iItem Then Set Menu = ToolBar_GetItem(CurhWnd, NMTBR.iItem)
          Allow = True
          RaiseEvent CustomizeQueryDelete(Menu, Allow)
          ReturnMessage = IIf(Allow, 1, 0)
        Case TBN_TOOLBARCHANGE
          Call CopyMemory(NMHDR, ByVal lParam, Len(NMHDR))
          RaiseEvent Change
        Case TBN_CUSTHELP
          Call CopyMemory(NMHDR, ByVal lParam, Len(NMHDR))
          RaiseEvent CustomizeHelp
#If (WIN32_IE >= IE4) Then
        Case TBN_HOTITEMCHANGE
          Call CopyMemory(NMHOTITEM, ByVal lParam, LenB(NMHOTITEM))
          Allow = True
          If NMHOTITEM.dwFlags And tbrHIEntering Then
            RaiseEvent HotItemChange(Nothing, ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idNew), NMHOTITEM.dwFlags, Allow)
          ElseIf NMHOTITEM.dwFlags And tbrHILeaving Then
            RaiseEvent HotItemChange(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idOld), Nothing, NMHOTITEM.dwFlags, Allow)
          Else
            Set Menu = ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idNew)
            RaiseEvent HotItemChange(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idOld), Menu, NMHOTITEM.dwFlags, Allow)
          End If
          ReturnMessage = IIf(Allow, 0, 1)
        Case TBN_DRAGOUT
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          RaiseEvent MenuDragOut(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem))
        Case TBN_DELETINGBUTTON
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          Set Menu = ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem)
          Call Menu.MenuBarMenu_Available(False)
          RaiseEvent MenuDeleting(Menu)
#End If
#If (WIN32_IE >= IE5) Then
        Case TBN_INITCUSTOMIZE
          Call CopyMemory(NMHDR, ByVal lParam, Len(NMHDR))
          Allow = True
          RaiseEvent CustomizeShowDlg(Allow)
          If Not Allow Then ReturnMessage = TBNRF_HIDEHELP
#End If
      End Select
  End Select
End Sub

'-----------------------------------------------------------
' Hooking

Private Sub Hooks_KeyboardProc(ByVal IsRemoved As Boolean, ByVal VKeyCode As Long, ByVal RepeatCount As Integer, ByVal ScanCode As Byte, ByVal ExtendedKey As Boolean, ByVal ContextCode As Boolean, ByVal KeyUp As Boolean, ByVal TransitionState As Boolean, ConsumeMsg As Boolean)
  Dim I As Long
  Dim NumButtons As Long
  Dim Menu As MenuBarMenu
  Dim MenuItem As PopupMenus.MenuItem
  Dim DWORD As DWORD
  Dim DWORD_N As DWORD_LONG
  
  If MenuBar_IsParentActive(CurhWnd) Then
    If IsWindowVisible(CurhWnd) <> 0 Then
      If IsRemoved Then
        Select Case VKeyCode
          Case vbKeyMenu ' SELECT FIRST MENU
              If Not ContextCode And KeyUp Then
                If CurMenuLevel = 0 And CurActiveMenuIndex = 0 Then
                  Debug.Print "Select the first menu"
                  ConsumeMsg = True
                  CurActiveMenuIndex = 1
                  Call SendMessage(CurhWnd, TB_SETHOTITEM, 0, ByVal 0)
                End If ' Menulevel, Menu Index
              End If ' Context, KeyUp
        End Select
      Else
        Select Case VKeyCode
          Case vbKeyMenu  ' UNHILITE MENUS
              If Not ContextCode Then
                If Not KeyUp Then
                  If CurActiveMenuIndex = -1 Then
                    CurActiveMenuIndex = 0
                    ConsumeMsg = True
                  ElseIf CurActiveMenuIndex <> 0 Then
                    Debug.Print "End the menu, unhilite buttons! AT LEVEL " & CurMenuLevel
                    Call EndMenu
                    ConsumeMsg = True
                    CurActiveMenuIndex = -1
                    Call SendMessage(CurhWnd, TB_SETHOTITEM, -1, ByVal 0)
                  End If ' Menu Index
                End If ' KeyUp
              End If ' Context
          Case vbKeyEscape ' UNHILITE BUTTONS
              If CurActiveMenuIndex > 0 And CurMenuLevel = 0 Then
                CurActiveMenuIndex = 0
                Call SendMessage(CurhWnd, TB_SETHOTITEM, -1, ByVal 0)
                ConsumeMsg = True
              End If
          Case vbKeyF10   ' SELECT FIRST MENU
              If (Not KeyUp) And CurMenuLevel = 0 Then
                CurActiveMenuIndex = 1
                Call SendMessage(CurhWnd, TB_SETHOTITEM, 0, ByVal 0)
                ConsumeMsg = True
              End If
          Case vbKeyLeft  ' PREVIOUS MENU
              If (Not TransitionState) And CurActiveMenuIndex > 0 Then
                ' Get Neighbour button/menu
                NumButtons = SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
                I = IIf(CurActiveMenuIndex <= 1, NumButtons, CurActiveMenuIndex - 1)
                If CurMenuLevel > 0 Then
                  ' If already in menu: If this button won't
                  ' close a submenu, Open next button menu
                  If (CurMenuLevel = 1) Then
                    Set Menu = ToolBar_GetItem(CurhWnd, I - 1)
                    CurMenuChangeByKey = True
                  End If
                Else
                  ' Just hilite next menu item
                  CurActiveMenuIndex = I
                  Call SendMessage(CurhWnd, TB_SETHOTITEM, I - 1, ByVal 0)
                  ConsumeMsg = True
                End If
              End If
          Case vbKeyRight ' NEXT MENU
              If (Not TransitionState) And CurActiveMenuIndex > 0 Then
                ' Get Neighbour button/menu
                NumButtons = SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
                I = IIf(CurActiveMenuIndex >= NumButtons, 1, CurActiveMenuIndex + 1)
                If CurMenuLevel > 0 Then
                  ' If already in menu: If this button won't
                  ' open a submenu, Open next submenu
                  If (Not CurTSelOpensMenu) Then
                    Set Menu = ToolBar_GetItem(CurhWnd, I - 1)
                    CurMenuChangeByKey = True
                  End If
                Else
                  ' Just hilite next menu item
                  CurActiveMenuIndex = I
                  Call SendMessage(CurhWnd, TB_SETHOTITEM, I - 1, ByVal 0)
                  ConsumeMsg = True
                End If
              End If
          Case vbKeyUp, vbKeyDown, vbKeyReturn ' EXECUTE
              If (Not KeyUp) And CurActiveMenuIndex > 0 And CurMenuLevel = 0 Then
                Set Menu = ToolBar_GetItem(CurhWnd, CurActiveMenuIndex - 1)
              End If
          Case Is >= 65
              If Not ExtendedKey And KeyUp And (ContextCode Or (CurActiveMenuIndex > 0 And CurMenuLevel = 0)) Then
                ' Open a menu if it's attached to the accelerator
                If VKeyCode <= 90 Then ' A-Z
#If (WIN32_IE >= IE4) Then
                  On Error Resume Next
                    Set Menu = Me.MapAccelerator(VKeyCode)
                  On Error GoTo 0
                  If Menu Is Nothing Then
#End If
                    For I = 1 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
                      If Asc(MB_Menus.Item(I).Accelerator) = VKeyCode Then
                        Set Menu = MB_Menus(I)
                        Exit For
                      End If
                    Next
#If (WIN32_IE >= IE4) Then
                  End If
#End If
                  ' No accel found? (ex: Alt+F4)
                  ' msg can be passed to next hook,
                  ' nothing found? simply no action at all.
                End If ' Keyrange
              End If
        End Select
        
        ' Open a submenu if parent menu button specified
        If Not Menu Is Nothing Then
          DWORD.LoWord = Menu.ID
          DWORD.HiWord = mbrFromAccelerator
          LSet DWORD_N = DWORD
          Call EndMenu
          Call PostMessage(UserControl.hWnd, WM_COMMAND, DWORD_N.N, ByVal CurhWnd)
          ConsumeMsg = True
        End If ' Popup
      End If ' IsRemoved
    End If ' Window Visible
    
    If CurMenuLevel = 0 And Not ConsumeMsg And Not KeyUp Then
      Dim Modifier As ShiftConstants
      If (GetAsyncKeyState(vbKeyControl) <> 0) Then Modifier = Modifier Or vbCtrlMask
      If (GetAsyncKeyState(vbKeyShift) <> 0) Then Modifier = Modifier Or vbShiftMask
      If ContextCode Then Modifier = Modifier Or vbAltMask
      If MenuPopup_ShortCutValid(Modifier, VKeyCode) Then
        Set MenuItem = MenuBar_GetMenuItemFromSC(MB_Menus, Modifier, VKeyCode)
        If Not MenuItem Is Nothing Then
          ConsumeMsg = True
          If (MenuItem.MenuState And mnuStateGrayed) = 0 Then
            ' Bingo! Got shortcut!
            DWORD.LoWord = MenuItem.ID
            DWORD.HiWord = mbrFromAccelerator
            LSet DWORD_N = DWORD
            Call PostMessage(UserControl.hWnd, WM_COMMAND, DWORD_N.N, ByVal 0)
          End If ' Menu active
        End If ' Got menuitem
      End If ' Valid shortcut
    End If ' MenuLevel 0 for shortcut, Not comsumed, Not keyup
    
    
  End If ' all parents enabled
End Sub

Private Sub Hooks_MessageProc(ByVal code As Hooking.HookingMessageCodes, ByVal MsghWnd As Long, ByVal MsgWindowMessage As Long, ByVal MsgwParam As Long, ByVal MsglParam As Long, ByVal MsgTime As Long, ByVal MsgMouseX As Long, ByVal MsgMouseY As Long, ConsumeMsg As Boolean)
  If code = Hooking.whkMsgMenu Then
    Select Case MsgWindowMessage
      Case WM_MOUSEMOVE, WM_LBUTTONDOWN
        ' Toolbar doesn't process any mouse messages
        ' when not active, so we do it here:
        Dim MousePt As POINTAPI
        Dim WinRect As RECT
        Dim Menu As MenuBarMenu
        Dim MenuIndex As Long

        If WindowFromPoint(MsgMouseX, MsgMouseY) = CurhWnd Then
          MousePt.X = MsgMouseX
          MousePt.Y = MsgMouseY
          Call ScreenToClient(CurhWnd, MousePt)
          If GetClientRect(CurhWnd, WinRect) <> 0 Then
            If (WinRect.Left <= MousePt.X And MousePt.X <= WinRect.Right And _
                WinRect.Top <= MousePt.Y And MousePt.Y <= WinRect.Bottom) Then ' PtInRect
              MsgMouseX = MousePt.X
              MsgMouseY = MousePt.Y
              
              Set Menu = Me.HitTest(MsgMouseX, MsgMouseY)
              If Not Menu Is Nothing Then
                MenuIndex = Menu.Index
                If MsgWindowMessage = WM_MOUSEMOVE Then
                  If MenuIndex <> CurActiveMenuIndex And CurActiveMenuIndex > 0 Then
                    If Not CurMenuChangeByKey Then
                      Dim Allow As Boolean
                      Allow = True
                      RaiseEvent HotItemChange(ToolBar_GetItem(CurhWnd, CurActiveMenuIndex - 1), Menu, tbrHIMouse, Allow)
                      If Allow Then
                        ConsumeMsg = True
                        Call EndMenu
                        Call PostMessage(CurhWnd, WM_COMMAND, Menu.ID, ByVal CurhWnd)
                      End If ' Allow
                    Else
                      CurMenuChangeByKey = False
                    End If ' What triggered this event?
                  End If ' Menuindex
                ElseIf MsgWindowMessage = WM_LBUTTONDOWN Then
                  If MenuIndex = CurActiveMenuIndex Then
                    ' user clicked on same button I am tracking: cancel menu
                    Debug.Print "YES - DOUBLE CLICK!"
                    Call SendMessage(CurhWnd, TB_SETHOTITEM, -1, ByVal 0)
                    CurActiveMenuIndex = -1
                    Call EndMenu
                    ConsumeMsg = True
                  End If ' Cur menu index
                End If ' Message test again
              End If ' Got menu
            End If ' pt in rect
          End If ' Clientrect fail
        End If ' Window from point
    End Select
  End If
End Sub

'Private Sub UserControl_AmbientChanged(PropertyName As String)
'  If UserControl.Ambient.UserMode And CurhWnd <> 0 Then
'    If StrComp(PropertyName, "UIDead") = 0 Then
'      MenuBar_KeyHooked = (UserControl.Ambient.UIDead = False) And UserControl.Enabled
'    End If
'  End If
'End Sub

'===========================================================


'-----------------------------------------------------------
' Class Interface

Private Sub UserControl_Initialize()
  Dim InitCCEx As tagInitCommonControlsEx
  InitCCEx.lngSize = LenB(InitCCEx)
  InitCCEx.lngICC = ICC_BAR_CLASSES
  Call InitCommonControlsEx(InitCCEx)
  CurSmartResize = True
  Erase CurActivehMenus
End Sub

Private Sub UserControl_InitProperties()
  Call MenuBar_Create
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  If CurhWnd = 0 Then Call MenuBar_Create
  #If Not DISALLOW_CUSTOMIZEPROP Then
    Me.Ajustable = PropBag.ReadProperty("Ajustable", tbrShiftDrag)
  #End If
  Me.Enabled = PropBag.ReadProperty("Enabled", True)
  Me.SmartResize = PropBag.ReadProperty("SmartResize", True)
  Me.Wrappable = PropBag.ReadProperty("Wrappable", True)
#If (WIN32_IE >= IE4) Then
  Me.BackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
  Me.CustomMenuColors = PropBag.ReadProperty("CustomMenuColors", False)
  If Me.CustomMenuColors Then
    Me.MenuHighlightColor = PropBag.ReadProperty("MenuHighlightColor", CLR_LIGHT_BORDER)
    Me.MenuShadowColor = PropBag.ReadProperty("MenuShadowColor", CLR_SHADOW_BORDER)
  End If
  Me.PaddingWidth = PropBag.ReadProperty("PaddingWidth", 7)
  Me.PaddingHeight = PropBag.ReadProperty("PaddingHeight", 6)
  Me.UseBackground = PropBag.ReadProperty("UseBackground", True)
#End If
End Sub

Private Sub UserControl_Show()
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_SHOWWINDOW)
End Sub

Private Sub UserControl_Hide()
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_HIDEWINDOW)
  If UserControl.Ambient.UserMode Then MenuBar_MsgHooked = False
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  #If Not DISALLOW_CUSTOMIZEPROP Then
    Call PropBag.WriteProperty("Ajustable", Me.Ajustable, tbrNotAjustable) ' tbrShiftDrag
  #End If
  Call PropBag.WriteProperty("Enabled", Me.Enabled, True)
  Call PropBag.WriteProperty("SmartResize", Me.SmartResize, True)
  Call PropBag.WriteProperty("Wrappable", Me.Wrappable, True)
#If (WIN32_IE >= IE4) Then
  Call PropBag.WriteProperty("BackColor", Me.BackColor, vbButtonFace)
  Call PropBag.WriteProperty("CustomMenuColors", Me.CustomMenuColors, False)
  Call PropBag.WriteProperty("MenuHighlightColor", Me.MenuHighlightColor, CLR_LIGHT_BORDER)
  Call PropBag.WriteProperty("MenuShadowColor", Me.MenuShadowColor, CLR_SHADOW_BORDER)
  Call PropBag.WriteProperty("PaddingHeight", Me.PaddingHeight, 6)
  Call PropBag.WriteProperty("PaddingWidth", Me.PaddingWidth, 7)
  Call PropBag.WriteProperty("UseBackground", Me.UseBackground, True)
#End If
End Sub

Public Property Get Left() As Long
Attribute Left.VB_Description = "Returns the left position of the menubar."
  Dim rctTbr As RECT
  Dim rctCtl As RECT
  Call GetClientRect(UserControl.hWnd, rctCtl)
  Call GetClientRect(CurhWnd, rctTbr)
  Left = rctCtl.Left
End Property

Public Property Get Top() As Long
Attribute Top.VB_Description = "Defines the top position of the menubar."
  Dim rctTbr As RECT
  Dim rctCtl As RECT
  Call GetClientRect(UserControl.hWnd, rctCtl)
  Call GetClientRect(CurhWnd, rctTbr)
  Top = rctCtl.Top
End Property

Private Sub UserControl_Resize()
  If Not CurResizing And CurhWnd <> 0 Then
    CurResizing = True ' Avoid recursive calls from usercontrol's winproc
    
    Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, UserControl.ScaleHeight, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER)
    
    If CurSmartResize Then
      UserControl.Width = UserControl.ScaleX(Me.ContentWidth, vbPixels, vbTwips) + (UserControl.Width - UserControl.ScaleX(UserControl.ScaleWidth, UserControl.ScaleMode, vbTwips))
      UserControl.Height = UserControl.ScaleY(Me.ContentHeight, vbPixels, vbTwips) + (UserControl.Height - UserControl.ScaleY(UserControl.ScaleHeight, UserControl.ScaleMode, vbTwips))
      Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, UserControl.ScaleHeight, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER)
    Else
      Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, Me.ContentWidth, Me.ContentHeight, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER)
    End If
    
    CurResizing = False
  End If
End Sub

Private Sub UserControl_Terminate()
  If EventHandler.Attached(UserControl.hWnd) Then EventHandler.Attached(UserControl.hWnd) = False
  If Hooks.Hooked(Hooking.whkMessageFilter) Then Hooks.Hooked(Hooking.whkMessageFilter) = False: Debug.Assert False
  If Hooks.Hooked(Hooking.whkKeyboardStrokes) Then Hooks.Hooked(Hooking.whkKeyboardStrokes) = False
  Set MB_Menus = Nothing
  Call DestroyWindow(CurhWnd)
  CurhWnd = 0
End Sub


'===========================================================


'----------------------------------------------------------
' hWnd

Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns the current window handle to the menubar (which is actually a toolbar window!)."
'  hWnd = UserControl.hWnd
  hWnd = CurhWnd
End Property

Public Property Get hWndMenuHandling() As Long
Attribute hWndMenuHandling.VB_Description = "Returns the handle of the window where all menu messages should be posted to, in order to get some events of this control raised!"
Attribute hWndMenuHandling.VB_UserMemId = 0
Attribute hWndMenuHandling.VB_MemberFlags = "200"
  hWndMenuHandling = UserControl.hWnd
End Property

Public Sub AboutBox()
Attribute AboutBox.VB_Description = "Displays an about dialog box"
Attribute AboutBox.VB_UserMemId = -552
Attribute AboutBox.VB_MemberFlags = "40"
  frmAbout.Show vbModal
End Sub

'----------------------------------------------------------
' Menus

Public Property Get Menus() As MenuBarMenus
Attribute Menus.VB_Description = "Contains the menus of the menubar."
  Set Menus = MB_Menus
End Property

Public Property Get CurSubMenu(Optional ByVal MenuLevel As Long) As PopupMenus.MenuContainer
Attribute CurSubMenu.VB_Description = "Returns information about the current submenu path the user is in."
  If CurMenuLevel Then
    If MenuLevel = 0 Then MenuLevel = CurMenuLevel
    Set CurSubMenu = MenuBar_GetMenu(CurActivehMenus(MenuLevel - 1))
  End If
End Property

Public Property Get CurSubMenuLevels() As Long
Attribute CurSubMenuLevels.VB_Description = "Returns the submenu level the user is in."
  CurSubMenuLevels = CurMenuLevel
End Property

Public Function HitTest(PtX As Long, PtY As Long, Optional ReturnNearest As Boolean, Optional NearestReturnPtr As Boolean) As MenuBarMenu
Attribute HitTest.VB_Description = "Preforms a so-called hit-test, which tells you which button the mouse is hovering over now."
  Dim Pos As Long
  Dim Coord As POINTAPI
  Coord.X = PtX
  Coord.Y = PtY
  Pos = SendMessage(CurhWnd, TB_HITTEST, 0, Coord)
  If ReturnNearest Then
    NearestReturnPtr = (Pos >= 0) ' Returned nearest when pos is neg
    Pos = Abs(Pos)
  End If
  If Pos >= 0 And Pos < SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) Then
    Set HitTest = ToolBar_GetItem(CurhWnd, Pos)
  End If
End Function

#If (WIN32_IE >= IE4) Then
  Public Function MapAccelerator(KeyCode As Long) As MenuBarMenu
Attribute MapAccelerator.VB_Description = "Converts an accelerator key to a menubar button."
    Dim Pos As Long
    If SendMessage(CurhWnd, TB_MAPACCELERATOR, KeyCode, Pos) <> 0 Then
      Set MapAccelerator = ToolBar_GetItemFromID(CurhWnd, Pos)
    End If
  End Function
#End If

Public Sub SetMenuMMWidth(MinWidth As Long, MaxWidth As Long)
Attribute SetMenuMMWidth.VB_Description = "Defines the menbar button min/max width."
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD.LoWord = MinWidth
  DWORD.HiWord = MaxWidth
  LSet DWORD_LONG = DWORD
  If SendMessage(CurhWnd, TB_SETBUTTONWIDTH, 0, ByVal DWORD_LONG.N) = 0 Then Error 5
End Sub

#If (WIN32_IE >= IE4) Then
  Public Property Get CustomMenuColors() As Boolean
Attribute CustomMenuColors.VB_Description = "Specifies if custom menu button colors are used."
    CustomMenuColors = CurUseCustomColors
  End Property
  
  Public Property Let CustomMenuColors(NewValue As Boolean)
    CurUseCustomColors = NewValue
    Dim Colors As COLORSCHEME
    Colors.dwSize = LenB(Colors)
    If NewValue = False Then
      Colors.clrBtnHighlight = tbrColorDefault
      Colors.clrBtnShadow = tbrColorDefault
    Else
      Colors.clrBtnHighlight = CoolBar_CColor(CLR_LIGHT_BORDER)
      Colors.clrBtnShadow = CoolBar_CColor(CLR_SHADOW_BORDER)
    End If
    CurMenuHighlight = CLR_LIGHT_BORDER
    CurMenuShadow = CLR_SHADOW_BORDER
    CommonControls_ColorScheme(CurhWnd) = Colors
    PropertyChanged "CustomMenuColors"
  End Property
  
  Public Property Get MenuHighlightColor() As OLE_COLOR
Attribute MenuHighlightColor.VB_Description = "Defines a custom menu button color."
    MenuHighlightColor = CommonControls_ColorScheme(CurhWnd).clrBtnHighlight
    If MenuHighlightColor = CoolBar_CColor(CurMenuHighlight) Then MenuHighlightColor = CurMenuHighlight
    If MenuHighlightColor = tbrColorDefault And Not CurUseCustomColors Then MenuHighlightColor = CLR_LIGHT_BORDER
  End Property
  
  Public Property Let MenuHighlightColor(NewValue As OLE_COLOR)
    If Not CurUseCustomColors Then Error 383
    Dim Colors As COLORSCHEME
    Colors = CommonControls_ColorScheme(CurhWnd)
    If NewValue <> tbrColorDefault Then
      Colors.clrBtnHighlight = CoolBar_CColor(NewValue)
      If Colors.clrBtnHighlight = -1 Then Error 380
    Else
      Colors.clrBtnHighlight = NewValue
    End If
    CommonControls_ColorScheme(CurhWnd) = Colors
    PropertyChanged "MenuHighlightColor"
  End Property
  
  Public Property Get MenuShadowColor() As OLE_COLOR
Attribute MenuShadowColor.VB_Description = "Defines a custom menu button color."
    MenuShadowColor = CommonControls_ColorScheme(CurhWnd).clrBtnShadow
    If MenuShadowColor = CoolBar_CColor(CurMenuShadow) Then MenuShadowColor = CurMenuShadow
    If MenuShadowColor = tbrColorDefault And Not CurUseCustomColors Then MenuShadowColor = CLR_SHADOW_BORDER
  End Property
  
  Public Property Let MenuShadowColor(NewValue As OLE_COLOR)
    If Not CurUseCustomColors Then Error 383
    Dim Colors As COLORSCHEME
    Colors = CommonControls_ColorScheme(CurhWnd)
    If NewValue <> tbrColorDefault Then
      Colors.clrBtnShadow = CoolBar_CColor(NewValue)
      If Colors.clrBtnShadow = -1 Then Error 380
    Else
      Colors.clrBtnShadow = NewValue
    End If
    CommonControls_ColorScheme(CurhWnd) = Colors
    PropertyChanged "MenuShadowColor"
  End Property
  
  Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/Sets the background color."
    BackColor = UserControl.BackColor
  End Property
  
  Public Property Let BackColor(NewValue As OLE_COLOR)
    UserControl.BackColor = NewValue
    PropertyChanged "BackColor"
  End Property
#End If

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Defines whether the menubar responds to user generated events."
  Enabled = IsWindowEnabled(CurhWnd)
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
  Call EnableWindow(CurhWnd, IIf(NewValue, 1, 0))
  UserControl.Enabled = NewValue
  MenuBar_KeyHooked = NewValue
End Property


'----------------------------------------------------------
' Subs

Public Sub AutoSize()
Attribute AutoSize.VB_Description = "Let's the menubar autosize itself"
  Call SendMessage(CurhWnd, TB_AUTOSIZE, 0, ByVal 0)
End Sub

Public Property Get SmartResize() As Boolean
Attribute SmartResize.VB_Description = "Defines the resizing behavour of the menubar."
  SmartResize = CurSmartResize
End Property

Public Property Let SmartResize(NewValue As Boolean)
  CurSmartResize = NewValue
  Call UserControl_Resize
  PropertyChanged "SmartResize"
End Property

Public Sub Customize()
Attribute Customize.VB_Description = "Occures when the user custumizes the menubar."
Attribute Customize.VB_MemberFlags = "40"
  Call SendMessage(CurhWnd, TB_CUSTOMIZE, 0, ByVal 0)
End Sub

Public Sub SaveSettings(HKEY As RegHKEYConstants, SubKeyName As String, Value As String)
Attribute SaveSettings.VB_Description = "Occures when the settings are being saved."
  Dim Settings As TBSAVEPARAMS
  Settings.HKEY = HKEY
  Settings.pszSubKey = VarPtr(SubKeyName)
  Settings.pszValueName = VarPtr(Value)
  Call SendMessage(CurhWnd, TB_SAVERESTORE, 1, Settings)
End Sub

Public Sub RestoreSettings(HKEY As RegHKEYConstants, SubKeyName As String, Value As String)
Attribute RestoreSettings.VB_Description = "Occures when all settings are restored."
  Dim Settings As TBSAVEPARAMS
  Settings.HKEY = HKEY
  Settings.pszSubKey = VarPtr(SubKeyName)
  Settings.pszValueName = VarPtr(Value)
  Call SendMessage(CurhWnd, TB_SAVERESTORE, 0, Settings)
End Sub

Public Property Get MenuDrawTextFlags(Optional MaskBits As TbrButtonTextFlags = &HFFFFFFFF) As TbrButtonTextFlags
Attribute MenuDrawTextFlags.VB_Description = "Specifies GDI drawtext flags used by the menubar to draw the buttons."
  MenuDrawTextFlags = SendMessage(CurhWnd, TB_SETDRAWTEXTFLAGS, 0, ByVal 0)
End Property

Public Property Let MenuDrawTextFlags(Optional MaskBits As TbrButtonTextFlags = &HFFFFFFFF, NewValue As TbrButtonTextFlags)
  Call SendMessage(CurhWnd, TB_SETDRAWTEXTFLAGS, MaskBits, ByVal NewValue)
End Property

Public Property Let MenuIndent(NewValue As Long)
Attribute MenuIndent.VB_Description = "Defines the indent of the menubar's content."
  If SendMessage(CurhWnd, TB_SETINDENT, NewValue, ByVal 0) = 0 Then Error 380
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get HotMenu() As MenuBarMenu
Attribute HotMenu.VB_Description = "Defines which menu is hot; that means selected."
    Dim HotItem As Long
    HotItem = SendMessage(CurhWnd, TB_GETHOTITEM, 0, ByVal 0)
    If HotItem = -1 Then Exit Property
    Set HotMenu = ToolBar_GetItem(CurhWnd, HotItem)
  End Property
  
  Public Property Let HotMenu(NewValue As MenuBarMenu)
    If NewValue Is Nothing Then
      Call SendMessage(CurhWnd, TB_SETHOTITEM, -1, ByVal 0)
    Else
      If Not TypeOf NewValue Is MenuBarMenu Then Error 380
      Call SendMessage(CurhWnd, TB_SETHOTITEM, NewValue.Index - 1, ByVal 0)
    End If
  End Property
#End If

Public Property Get ContentWidth() As Long
Attribute ContentWidth.VB_Description = "Returns the width of the menubar contents, i.e. all it's buttons."
  Dim rctMenu As RECT
  Dim rctTotal As RECT
  Dim I As Long
  
  For I = 0 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) - 1
    If SendMessage(CurhWnd, TB_GETITEMRECT, I, rctMenu) <> 0 Then
      If UnionRect(rctTotal, rctTotal, rctMenu) = 0 Then Error 5
    End If
  Next
  ContentWidth = rctTotal.Right + 2 * rctTotal.Left ' BORDER
End Property

Public Property Get ContentHeight() As Long
Attribute ContentHeight.VB_Description = "Returns the height of the menubar contents, i.e. all it's buttons."
  Dim rctMenu As RECT
  Dim rctTotal As RECT
  Dim I As Long
  
  For I = 0 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) - 1
    If SendMessage(CurhWnd, TB_GETITEMRECT, I, rctMenu) <> 0 Then
      If UnionRect(rctTotal, rctTotal, rctMenu) = 0 Then Error 5
    End If
  Next
  ContentHeight = rctTotal.Bottom - rctTotal.Top + 2 * rctTotal.Top  ' BORDER
#If (WIN32_IE >= IE4) Then
  On Error Resume Next
    I = Me.MaxContentHeight
  On Error GoTo 0
  If ContentHeight < I Then ContentHeight = I
#End If
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get MaxContentWidth() As Long
Attribute MaxContentWidth.VB_Description = "Defines what the maximum content width of the menubar can be."
    Dim SIZE As SIZE
    If SendMessage(CurhWnd, TB_GETMAXSIZE, 0, SIZE) = 0 Then Error 5
    MaxContentWidth = SIZE.cx
  End Property
  
  Public Property Get MaxContentHeight() As Long
Attribute MaxContentHeight.VB_Description = "Defines the maximun height of the content of the menubar can be."
    Dim SIZE As SIZE
    If SendMessage(CurhWnd, TB_GETMAXSIZE, 0, SIZE) = 0 Then Error 5
    MaxContentHeight = SIZE.cy
  End Property
  
  Public Sub SetPadding(Width As Integer, Height As Integer)
Attribute SetPadding.VB_Description = "Sets the menubar button padding."
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD.LoWord = Width
    DWORD.HiWord = Height
    LSet DWORD_LONG = DWORD
    Call SendMessage(CurhWnd, TB_SETPADDING, 0, ByVal DWORD_LONG.N)
    Call ToolBar_Update(CurhWnd, CurRunMode)
  End Sub
  
  Public Property Get PaddingWidth() As Integer
Attribute PaddingWidth.VB_Description = "Defines the menbar button padding width"
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD_LONG.N = SendMessage(CurhWnd, TB_GETPADDING, 0, ByVal 0)
    LSet DWORD = DWORD_LONG
    PaddingWidth = DWORD.LoWord
  End Property
  
  Public Property Let PaddingWidth(NewValue As Integer)
    Call Me.SetPadding(NewValue, Me.PaddingHeight)
    PropertyChanged "PaddingWidth"
  End Property
  
  Public Property Get PaddingHeight() As Integer
Attribute PaddingHeight.VB_Description = "Defines the menbar button padidng height."
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD_LONG.N = SendMessage(CurhWnd, TB_GETPADDING, 0, ByVal 0)
    LSet DWORD = DWORD_LONG
    PaddingHeight = DWORD.HiWord
  End Property
  
  Public Property Let PaddingHeight(NewValue As Integer)
    Call Me.SetPadding(Me.PaddingWidth, NewValue)
    PropertyChanged "PaddingHeight"
  End Property
#End If

Public Property Get MenuRows(Optional AllowMoreWhenNotFit As Boolean = True) As Long
Attribute MenuRows.VB_Description = "Defines how many menu button rows are used when wrappable is enabled."
  If AllowMoreWhenNotFit = False Then Error 5
  MenuRows = SendMessage(CurhWnd, TB_GETROWS, 0, ByVal 0)
End Property

Public Property Let MenuRows(Optional AllowMoreWhenNotFit As Boolean = True, NewValue As Long)
  Dim NewRect As RECT
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD.LoWord = CInt(NewValue)
  DWORD.HiWord = CInt(CByte(AllowMoreWhenNotFit))
  LSet DWORD_LONG = DWORD
  If NewValue < 0 Or NewValue > SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) Then Error 380
  Call SendMessage(CurhWnd, TB_SETROWS, DWORD_LONG.N, NewRect)
End Property


'----------------------------------------------------------
' Window Style Flags

Public Property Get Wrappable() As Boolean
Attribute Wrappable.VB_Description = "When true, buttons are wrapped to the next row when things don't fit anymore."
  Wrappable = (SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_WRAPABLE)
End Property

Public Property Let Wrappable(NewValue As Boolean)
  Dim MenuSize As Long
  MenuSize = SendMessage(CurhWnd, TB_GETBUTTONSIZE, 0, ByVal 0)
  Call ToolBar_StyleMod(CurhWnd, TBSTYLE_WRAPABLE, NewValue)
  If SendMessage(CurhWnd, TB_SETBUTTONSIZE, 0, ByVal MenuSize) = 0 Then Error 5
  Call ToolBar_Update(CurhWnd, CurRunMode)
  PropertyChanged "Wrappable"
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get UseBackground() As Boolean
Attribute UseBackground.VB_Description = "Sets transparency of the background on if true."
    UseBackground = (SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_TRANSPARENT)
  End Property
  
  Public Property Let UseBackground(NewValue As Boolean)
    Call ToolBar_StyleMod(CurhWnd, TBSTYLE_TRANSPARENT, NewValue)
    If IsWindowVisible(CurhWnd) <> 0 Then
      Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_HIDEWINDOW Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE)
      Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE)
    End If
    PropertyChanged "UseBackground"
  End Property
#End If

Public Property Get Ajustable() As TbrAjustableState
Attribute Ajustable.VB_Description = "Specifies if and how the menu should be adjustable."
Attribute Ajustable.VB_MemberFlags = "440"
  Dim Style As ToolBarStyles
  Style = SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0)
  If Style And CCS_ADJUSTABLE Then
    Ajustable = IIf(Style And TBSTYLE_ALTDRAG, tbrAltDrag, tbrShiftDrag)
  Else
    Ajustable = tbrNotAjustable
  End If
End Property

Public Property Let Ajustable(NewValue As TbrAjustableState)
  #If DISALLOW_CUSTOMIZEPROP Then
    If NewValue <> tbrNotAjustable Then Error 383
  #End If
  Call ToolBar_StyleMod(CurhWnd, CCS_ADJUSTABLE, NewValue <> tbrNotAjustable)
  Call ToolBar_StyleMod(CurhWnd, TBSTYLE_ALTDRAG, NewValue = tbrAltDrag)
  Call ToolBar_Update(CurhWnd, CurRunMode)
  PropertyChanged "Ajustable"
End Property


'----------------------------------------------------------
' Chevron Handeling!

Public Sub HandleChevron(ByVal AbsChevronLeft As Long, ByVal AbsChevronTop As Long, ByVal ChevronWidth As Long, ByVal ChevronHeight As Long, ByVal FirstInvisibleMenu As Long, Optional ByVal BandBackground As IPicture)
Attribute HandleChevron.VB_Description = "Generates a default response to the chrevron support of the possible rebar parent."
  Dim I As Long                              ' Illiterator
  Dim Menu As MenuBarMenu                    ' Source button/menu button
  Dim MenuStates As MbrMenuStates            ' Toolbar button/menu flags to be converted
  Dim MenuItemType As PopupMenus.MenuTypeFlags    ' Menu appearance
  Dim MenuItemStates As PopupMenus.MenuStateFlags ' Menu grayed, etc?
  
  Dim mnuPopup As MenuContainer              ' Result popup menu
  Dim MenuItem As MenuItem                   ' Popupmenu item
  
  If FirstInvisibleMenu Then
    Set mnuPopup = PopupMenus.CreateSubMenu()
    
    ' Convert ToolBar button Flags to menu flags.
    For I = FirstInvisibleMenu - 1 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) - 1
      Set Menu = ToolBar_GetItem(CurhWnd, I)
      If Not Menu.SubMenu Is Nothing Then
        MenuStates = Menu.State
        MenuItemStates = 0                                  ' Reset.
        MenuItemType = mnuFlagString Or mnuFlagDrawnByOwner ' Reset.
        If ((MenuStates And mbrStateHidden) = 0) And Not (Menu.ActSeparator And (MenuItem Is Nothing)) Then
          ' Not hidden, and first item not separator, then...
          If (Menu.ActSeparator) Then MenuItemType = MenuItemType Or mnuFlagSeparator
          If ((MenuStates And mbrStateEnabled) = 0) Then MenuItemStates = MenuItemStates Or mnuStateGrayed
'         If (MenuStates And mbrStateWrappedAfter) = mbrStateWrappedAfter Then MenuItemType = MenuItemType Or mnuFlagBreak
          Set MenuItem = mnuPopup.Menus.Add(Menu.ID, Menu.Caption, , , MenuItemType, MenuItemStates, , , , Menu.SubMenu)
          MenuItem.DrawExtras.Metrics(mnuMtrIconSize) = Menu.Height - (ICON_BORDER_TOP + ICON_BORDER_BOTTOM) - 1
        End If
      End If
    Next
    
    ' Only WM_COMMAND will be redirected to the parent window
    If Not BandBackground Is Nothing Then Set mnuPopup.DrawExtras.Background = BandBackground
    Call mnuPopup.PopupEx(CurhWnd, mnuPopupRightBtnClose, AbsChevronLeft, AbsChevronTop + ChevronHeight, AbsChevronLeft, AbsChevronTop, AbsChevronLeft + ChevronWidth, AbsChevronTop + ChevronHeight)
    ' Kill/release the menu. The remove loop prevents the submenus from
    ' being destroyed when then the menu itsself is released.
    For I = mnuPopup.Menus.Count To 1 Step -1
      Call mnuPopup.Menus.Remove(I, mnuItemByPosition, False)
    Next
    Set mnuPopup = Nothing
  End If
End Sub


'===========================================================


'----------------------------------------------------------
' ToolBar Code

Private Sub MenuBar_Create()
#If (WIN32_IE >= IE4) Then
'Or CCS_ADJUSTABLE
  CurhWnd = CreateWindowEx(WS_EX_TOOLWINDOW, TOOLBARCLASSNAME, "Xception's controls  - VB6 [MenuBar]", WS_CHILD Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or CCS_NOPARENTALIGN Or CCS_NORESIZE Or CCS_NODIVIDER Or TBSTYLE_FLAT Or TBSTYLE_LIST Or TBSTYLE_WRAPABLE Or TBSTYLE_TRANSPARENT, 0, 0, 2000, 22, UserControl.hWnd, 0, App.hInstance, Null)
#Else
  CurhWnd = CreateWindowEx(WS_EX_TOOLWINDOW, TOOLBARCLASSNAME, "Xception's controls  - VB6 [MenuBar]", WS_CHILD Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or CCS_NOPARENTALIGN Or CCS_NORESIZE Or CCS_NODIVIDER Or TBSTYLE_FLAT Or TBSTYLE_LIST Or TBSTYLE_WRAPABLE, 0, 0, 2000, 22, UserControl.hWnd, 0, App.hInstance, Null)
#End If
  Dim TBBUTTON As TBBUTTON
  Call SendMessage(CurhWnd, TB_BUTTONSTRUCTSIZE, LenB(TBBUTTON), ByVal 0)
  Call SetProp(CurhWnd, RBR_PROP_MSG, UserControl.hWnd)
  Call SendMessage(CurhWnd, TB_SETPARENT, UserControl.hWnd, ByVal 0)
  Call SendMessage(CurhWnd, TB_SETBITMAPSIZE, 0, ByVal 0)  ' (LPARAM) (DWORD) 0
  CurRunMode = UserControl.Ambient.UserMode
  Set MB_Menus = New MenuBarMenus
  Call MB_Menus.Class_InitProps(CurhWnd)
  Call Me.AutoSize
  Call SetProp(CurhWnd, MBR_PROP_ISMENUBAR, CLng(True))
  If Not UserControl.Ambient.UserMode Then
    Dim StartPos As Long
    With MB_Menus
      .Add , , "&File"
      .Add , , "&Edit"
      .Add , , "&View"
      .Add , , "E&xtra"
      .Add , , "&Window"
      .Add , , "&Help"
    End With
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_SHOWWINDOW)
  Else
    If True Or UserControl.Extender.Visible Then Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_SHOWWINDOW)
    EventHandler.Attached(UserControl.hWnd) = True
  End If
End Sub

Private Property Let MenuBar_KeyHooked(ByVal NewValue As Boolean)
  If NewValue Then
    If Hooks.Hooked(Hooking.whkKeyboardStrokes) Then
      Debug.Print "HOOKING: Already hooked keyboard!"
    Else
      Hooks.Hooked(Hooking.whkKeyboardStrokes) = True
    End If
  Else
    If Hooks.Hooked(Hooking.whkKeyboardStrokes) Then
      Hooks.Hooked(Hooking.whkKeyboardStrokes) = False
    Else
      Debug.Print "HOOKING: Not hooked keyboard at all!"
    End If
  End If
End Property

Private Property Let MenuBar_MsgHooked(ByVal NewValue As Boolean)
  If NewValue Then
    If Hooks.Hooked(Hooking.whkMessageFilter) Then
      Debug.Print "HOOKING: Already hooked messages!"
    Else
      Hooks.Hooked(Hooking.whkMessageFilter) = True
    End If
  Else
    If Hooks.Hooked(Hooking.whkMessageFilter) Then
      Hooks.Hooked(Hooking.whkMessageFilter) = False
    Else
      Debug.Print "HOOKING: Not hooked messages at all!"
    End If
  End If
End Property

