VERSION 5.00
Object = "{42D59A35-B688-11D5-ADA7-009027BF5C2D}#1.0#0"; "X-SubCls.ocx"
Begin VB.UserControl ToolBar 
   Alignable       =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   465
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5700
   ClipControls    =   0   'False
   EditAtDesignTime=   -1  'True
   FillStyle       =   0  'Solid
   FontTransparent =   0   'False
   HasDC           =   0   'False
   ScaleHeight     =   31
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   380
   ToolboxBitmap   =   "Controls - ToolBar.ctx":0000
   Begin SubClassing.EventHandler EventHandler 
      Left            =   0
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
   End
End
Attribute VB_Name = "ToolBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "Member0" ,"ToolBarButtons"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Option Explicit

'==================================================================
'
' ToolBar Control Class
'
' 1 October 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
' Important Note: *NEVER* re-compile the source code
' in it's current state. If you want to do that,
' please change the name of the project, and give the OCX
' an other filename then used. Actuallty, I would prefer
' you e-mail me the changes, so I release a new version of the OCX.
'
' Otherwise, some projects using the original DLL
' fail to run or crash at startup.
'
'==================================================================


'------------------------------------------------------------------------
' General Module Level Compiler Directoves

#Const DISALLOW_CUSTOMIZEPROP = True

#Const NO_IE = 0
#Const IE3 = 300
#Const IE4 = 400
#Const IE401 = 401
#Const IE5 = 500
#Const IE501 = 501

#Const WIN32_IE = IE5
#Const UNICODE = False  ' W9x (False) or NT (True)?


'-----------------------------------------------------------
' Current Properties

Private CurhWnd As Long
#If (WIN32_IE >= IE4) Then
  Private CurUseCustomColors As Boolean
  Private CurButtonHighlight As OLE_COLOR
  Private CurButtonShadow As OLE_COLOR
#End If
Private TB_Buttons As ToolBarButtons
Private CurBitmaps As Collection
Private CurResizing As Boolean
Private CurSmartResize As Boolean
Private CurRunMode As Boolean

Private CurImageList As ImageListCore.ImageList
Private CurDisabledImageList As ImageListCore.ImageList
Private CurHotImageList As ImageListCore.ImageList

Private CurLastParent As OLE_HANDLE
Private CurLastToolTip As String
Private CurLastToolTipButton As Long

#If (WIN32_IE >= IE4) Then
  Private Const CLR_LIGHT_BORDER = SystemColorConstants.vb3DHighlight
  Private Const CLR_SHADOW_BORDER = SystemColorConstants.vb3DShadow
#End If

Private CurRemovedNum As Long
Private CurRemoved() As TBBUTTON
Private CurRemovedInfo() As String


'-----------------------------------------------------------
' Public Enums

Public Enum TbrAjustableState
  tbrNotAjustable = 0
  tbrShiftDrag = 1
  tbrAltDrag = 2
End Enum

Public Enum TbrButtonTextFlags
  tbrDrawFlagAlignTop = &H0          ' DT_TOP
  tbrDrawFlagAlignLeft = &H0         ' DT_LEFT
  tbrDrawFlagAlignCenter = &H1       ' DT_CENTER
  tbrDrawFlagAlignRight = &H2        ' DT_RIGHT
  tbrDrawFlagAlignMiddle = &H4       ' DT_VCENTER
  tbrDrawFlagAlignBottom = &H8       ' DT_BOTTOM
  tbrDrawFlagWordBreak = &H10        ' DT_WORDBREAK
  tbrDrawFlagSingleLine = &H20       ' DT_SINGLELINE
  tbrDrawFlagExpandTaps = &H40       ' DT_EXPANDTABS
  tbrDrawFlagTabStop = &H80          ' DT_TABSTOP
  tbrDrawFlagNoClip                  ' DT_NOCLIP
  tbrDrawFlagExternalLeading = &H200 ' DT_EXTERNALLEADING
  tbrDrawFlagCalcRect = &H400        ' DT_CALCRECT
  tbrDrawFlagNoPrefix = &H800        ' DT_NOPREFIX
  tbrDrawFlagInternal = &H1000       ' DT_INTERNAL
  tbrDrawFlagEditControl = &H2000    ' DT_EDITCONTROL
  tbrDrawFlagPathEllipsis = &H4000   ' DT_PATH_ELLIPSIS
  tbrDrawFlagEndEllipsis = &H8000    ' DT_END_ELLIPSIS
  tbrDrawFlagModifyString = &H10000  ' DT_MODIFYSTRING
  tbrDrawFlagLTRReading = &H20000    ' DT_RTLREADING
  tbrDrawFlagWordEllipsis = &H40000  ' DT_WORD_ELLIPSIS
End Enum

Public Enum RegHKEYConstants
  HKEY_CLASSES_ROOT = &H80000000
  HKEY_CURRENT_USER = &H80000001
  HKEY_LOCAL_MACHINE = &H80000002
  HKEY_USERS = &H80000003
  HKEY_PERFORMANCE_DATA = &H80000004
  HKEY_CURRENT_CONFIG = &H80000005
  HKEY_DYN_DATA = &H80000006
End Enum

Public Enum TbrButtonIndex
  tbrButtonLeft = 0
  tbrButtonRight = 1
End Enum

Public Enum TbrCustomColorConstants
  tbrColorDefault = &HFF000000
  tbrColorNone = &HFFFFFFFF
End Enum

#If (WIN32_IE >= IE4) Then
  Public Enum TbrRequestType
    tbrNeedImage = &H1 ' TBNF_IMAGE
    tbrNeedText = &H2  ' TBNF_TEXT
  End Enum
  
  Public Enum TbrHotItemChangeFlags
    tbrHIOther = &H0                ' HICF_OTHER
    tbrHIMouse = &H1                ' HICF_MOUSE
    tbrHIArrow = &H2                ' HICF_ARROWKEYS
    tbrHIAccelerator = &H4          ' HICF_ACCELERATOR
    tbrHIAcceleratorDuplicate = &H8 ' HICF_DUPACCEL
    tbrHIEntering = &H10            ' HICF_ENTERING
    tbrHILeaving = &H20             ' HICF_LEAVING
    tbrHIReSelect = &H40            ' HICF_RESELECT
  End Enum
  
  Public Enum TbrDropDownState
    tbrDropDownHandled = 0      ' TBDDRET_DEFAULT
    tbrDropDownNotHandled = 1   ' TBDDRET_NODEFAULT
    tbrDropDownTreatPressed = 2 ' TBDDRET_TREATPRESSED
  End Enum
#End If

Public Enum TbrImageLists
  tbrIconStandardSmallColor = 0 ' IDB_STD_SMALL_COLOR
  tbrIconStandardLargeColor = 1 ' IDB_STD_LARGE_COLOR
  tbrIconViewSmallColor = 4     ' IDB_VIEW_SMALL_COLOR
  tbrIconViewLargeColor = 5     ' IDB_VIEW_LARGE_COLOR
  tbrIconHistorySmallColor = 8  ' IDB_HIST_SMALL_COLOR
  tbrIconHistoryLargeColor = 9  ' IDB_HIST_LARGE_COLOR
End Enum

Public Enum TbrImageListsStandardIcons
  tbrIconCut = 1           ' STD_CUT + 1
  tbrIconCopy = 2          ' STD_COPY + 1
  tbrIconPaste = 3         ' STD_PASTE + 1
  tbrIconUndo = 4          ' STD_UNDO + 1
  tbrIconRedo = 5          ' STD_REDOW + 1
  tbrIconDelete = 6        ' STD_DELETE + 1
  tbrIconFileNew = 7       ' STD_FILENEW + 1
  tbrIconFileOpen = 8      ' STD_FILEOPEN + 1
  tbrIconFileSave = 9      ' STD_FILEOPEN + 1
  tbrIconPrintPreview = 10 ' STD_PRINTPRE + 1
  tbrIconProperties = 11   ' STD_PROPERTIES + 1
  tbrIconHelp = 12         ' STD_HELP + 1
  tbrIconFind = 13         ' STD_FIND + 1
  tbrIconReplace = 14      ' STD_REPLACE + 1
  tbrIconPrint = 15        ' STD_PRINT + 1
End Enum

Public Enum TbrImageListsViewIcons
  tbrIconLargeIcons = 1     ' VIEW_LARGEICONS + 1
  tbrIconSmallIcons = 2     ' VIEW_SMALLICONS + 1
  tbrIconList = 3           ' VIEW_LIST + 1
  tbrIconDetails = 4        ' VIEW_DETAILS + 1
  tbrIconSortName = 5       ' VIEW_SORTNAME + 1
  tbrIconSortSize = 6       ' VIEW_SORTSIZE + 1
  tbrIconSortDate = 7       ' VIEW_SORTDATE + 1
  tbrIconSortType = 8       ' VIEW_SORTTYPE + 1
  tbrIconParentFolder = 9   ' VIEW_PARENTFOLDER + 1
  tbrIconNetConnect = 10    ' VIEW_NETCONNECT + 1
  tbrIconNetDisconnect = 11 ' VIEW_NETDISCONNECT + 1
  tbrIconNewFolder = 12     ' VIEW_NEWFOLDER + 1
#If (WIN32_IE >= IE4) Then
  tbrIconViewMenu = 13      ' VIEW_VIEWMENU + 1
#End If
End Enum

#If (WIN32_IE >= IE3) Then
  Public Enum TbrImageListsHistoryIcons
    tbrIconBack = 1             ' HIST_BACK + 1
    tbrIconForward = 2          ' HIST_FORWARD + 1
    tbrIconFavourites = 3       ' HIST_FAVORITES + 1
    tbrIconAddToFavourites = 4  ' HIST_ADDTOFAVORITES + 1
    tbrIconViewTree = 5         ' HIST_VIEWTREE + 1
  End Enum
#End If

Public Enum TbrBitmapFlags
  tbrBitmapSmallIcons = 0
  tbrBitmapLargeIcons = &H1 ' TBBF_LARGE
End Enum

Public Event Click(ByVal Button As TbrButtonIndex)
Attribute Click.VB_Description = "Occures when the user clicks on the toolbar."
Public Event DblClick(ByVal Button As TbrButtonIndex)
Attribute DblClick.VB_Description = "Occures when the user double-clicks on a button."
Public Event HitEnter()
Attribute HitEnter.VB_Description = "Occures when enter is pressed."
Public Event ToolBarGotFocus()
Attribute ToolBarGotFocus.VB_Description = "Occures when the toolbar gains focus."
Public Event ToolBarLostFocus()
Attribute ToolBarLostFocus.VB_Description = "Occures when the toolbar loses focus."
Public Event MouseMove()
Attribute MouseMove.VB_Description = "Occured when the mouse if moves over the toolbar."

Public Event ShowToolTip(ByVal Button As ToolBarButton, ByRef Text As String)
Attribute ShowToolTip.VB_Description = "Specifies if tooltips are used or not."
Public Event ButtonClick(ByVal Button As ToolBarButton)
Attribute ButtonClick.VB_Description = "Occures when a button is clicked."
Attribute ButtonClick.VB_UserMemId = -600
Attribute ButtonClick.VB_MemberFlags = "200"
Public Event ButtonDragInitialize(ByVal Button As ToolBarButton)
Attribute ButtonDragInitialize.VB_Description = "Occures when a button is about to be dragged."
Public Event ButtonDragTerminate(ByVal Button As ToolBarButton)
Attribute ButtonDragTerminate.VB_Description = "Occures when the user if finished dragging."
Public Event CustomizeInitialize(ByVal Button As ToolBarButton)
Attribute CustomizeInitialize.VB_MemberFlags = "40"
Public Event CustomizeTerminate(ByVal Button As ToolBarButton)
Attribute CustomizeTerminate.VB_MemberFlags = "40"
Public Event CustomizeShowDlg(ByRef ShowHelp As Boolean)
Attribute CustomizeShowDlg.VB_MemberFlags = "40"
Public Event CustomizeQueryInsert(ByVal Button As ToolBarButton, ByVal NewButtonIndex As Long, ByRef Allow As Boolean)
Attribute CustomizeQueryInsert.VB_MemberFlags = "40"
Public Event CustomizeQueryDelete(ByVal Button As ToolBarButton, ByRef Allow As Boolean)
Attribute CustomizeQueryDelete.VB_MemberFlags = "40"
Public Event CustomizeHelp()
Attribute CustomizeHelp.VB_Description = "Occures when the help button is pressed in the customize dialog box."
Attribute CustomizeHelp.VB_MemberFlags = "40"
Public Event CustomizeReset()
Attribute CustomizeReset.VB_Description = "Restores the entire toolbar button's state."
Attribute CustomizeReset.VB_MemberFlags = "40"
Public Event CustomizeChange()
Attribute CustomizeChange.VB_MemberFlags = "40"
Public Event SaveSettings()
Public Event RestoreSettings()
Public Event ButtonDragOut(ByVal Button As ToolBarButton)
Attribute ButtonDragOut.VB_Description = "Occures when a button is dragged out of the toolbar."
Public Event ButtonDeleting(ByVal Button As ToolBarButton)
Attribute ButtonDeleting.VB_Description = "Occures when a button is about to be deleted."
#If (WIN32_IE >= IE4) Then
  Public Event ButtonDropDown(ByVal Button As ToolBarButton, ByVal DropX As Long, ByVal DropY As Long, ByRef ReturnMessage As TbrDropDownState)
  Public Event HotItemChange(ByVal OldButton As ToolBarButton, ByVal NewButton As ToolBarButton, ByVal Flags As TbrHotItemChangeFlags, ByRef Allow As Boolean)
Attribute HotItemChange.VB_Description = "Occures when a different button is selected."
  Public Event NeedButtonInfo(ByVal Button As ToolBarButton, ByVal Requested As TbrRequestType, ByRef Text As String, ByRef ImageIndex As Long, ByRef KeepAsking As Boolean)
Attribute NeedButtonInfo.VB_Description = "Requests display information about a button."
  Public Event ReleaseCapture()
Attribute ReleaseCapture.VB_Description = "Occures when the mouse capture is released."
#End If
#If (WIN32_IE >= IE401) Then
  Public Event ToolTipsCreated(ByVal hWndTooltip As Long)
#End If



Private Sub EventHandler_ReceivedMessage(ByVal hWnd As Long, ByVal WindowMessage As Long, ByVal wParam As Long, ByVal lParam As Long, ReturnMessage As SubClassing.EventResultMessage)
  Dim I As Long
  Dim Button As ToolBarButton
  Dim Text As String
  Dim ByteStr() As Byte
  Dim Size1 As RECT
  Dim NMHDR As NMHDR
  Dim NMTBR As NMTOOLBAR
#If (WIN32_IE >= IE4) Then
  Dim NMHOTITEM As NMTBHOTITEM
  Dim NMTOOLTIP As NMTTDISPINFO
  Dim NMTBGETINFOTIP As NMTBGETINFOTIP
  Dim NMDISPINFO As NMTBDISPINFO
#End If
#If (WIN32_IE >= IE401) Then
  Dim NMTOOLCREATE As NMTOOLTIPSCREATED
#End If
  Dim NMSECRET As NMRB_SECRET
  Dim Allow As Boolean
  ReturnMessage = SubClassing.evtCallPrevWinProc
  
  Select Case WindowMessage
    Case WM_COMMAND
      If lParam = CurhWnd Then
        RaiseEvent ButtonClick(ToolBar_GetItemFromID(lParam, wParam))
        ReturnMessage = SubClassing.evtHandled
      Else
        Debug.Print "WM_COMMAND for hwnd:=&H" & Hex(lParam)
      End If
#If (WIN32_IE >= IE4) Then
    Case WM_SYSCOLORCHANGE
      ' This need to be done when we set the color explicitly
      Me.ButtonHighlightColor = Me.ButtonHighlightColor
      Me.ButtonShadowColor = Me.ButtonShadowColor
      ReturnMessage = SubClassing.evtHandled
#End If
    Case WM_ERASEBKGND ' Required when your control is hosting the toolbar itsself
      If GetParent(CurhWnd) = UserControl.hWnd Then
        Dim hBrush As OLE_HANDLE
        Call GetClientRect(CurhWnd, Size1)
        hBrush = CreateSolidBrush(CoolBar_CColor(UserControl.BackColor))
        Call FillRect(wParam, Size1, hBrush)
        Call DeleteObject(hBrush)
      End If
    Case WM_GETMINMAXINFO
      ReturnMessage = EventHandler.CallWinProc(CurhWnd, WindowMessage, wParam, lParam)
    Case WM_NOTIFY
      Call CopyMemory(NMHDR, ByVal lParam, Len(NMHDR))
      Select Case NMHDR.code
        ' SECRET REBAR NOTIFICATIONS!
        
        Case RbrSecretNotifications.RBN_CHILD_ATTACH
          Call CopyMemory(NMSECRET, ByVal lParam, Len(NMSECRET))
          If NMSECRET.hWndBandChild = CurhWnd Then
            UserControl.BackStyle = 0
          Else
            Debug.Assert False
          End If
        Case RbrSecretNotifications.RBN_CHILD_DETACH
          Call CopyMemory(NMSECRET, ByVal lParam, Len(NMSECRET))
          If NMSECRET.hWndBandChild = CurhWnd Then
            UserControl.BackStyle = 1
            Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, 0, 0, (SWP_NOACTIVATE Or SWP_NOSIZE Or SWP_FRAMECHANGED Or SWP_NOOWNERZORDER Or SWP_SHOWWINDOW))
          Else
            Debug.Assert False
          End If
          
        ' COMMON NOTIFICATIONS!
        
        Case NM_CUSTOMDRAW: Exit Sub
#If (WIN32_IE >= IE4) Then
        Case NM_NCHITTEST, NM_KEYDOWN, NM_SETCURSOR, NM_CHAR: Exit Sub
#End If
#If (WIN32_IE >= IE5) Then
        Case NM_LDOWN, NM_RDOWN: Exit Sub
#End If
        Case NM_OUTOFMEMORY:      Error 7
        Case NM_CLICK:            RaiseEvent Click(tbrButtonLeft)
        Case NM_RCLICK:           RaiseEvent Click(tbrButtonRight)
        Case NM_DBLCLK:           RaiseEvent DblClick(tbrButtonLeft)
        Case NM_RDBLCLK:          RaiseEvent DblClick(tbrButtonRight)
        Case NM_RETURN:           RaiseEvent HitEnter
        Case NM_SETFOCUS:         RaiseEvent ToolBarGotFocus
        Case NM_KILLFOCUS:        RaiseEvent ToolBarLostFocus
        Case NM_HOVER:            RaiseEvent MouseMove
#If (WIN32_IE >= IE4) Then
        Case NM_RELEASEDCAPTURE:  RaiseEvent ReleaseCapture
#End If
          
        ' TOOLTIP NOTIFICATIONS!
        
#If (WIN32_IE >= IE401) Then
        Case NM_TOOLTIPSCREATED
          Call CopyMemory(NMTOOLCREATE, ByVal lParam, Len(NMTOOLCREATE))
          RaiseEvent ToolTipsCreated(NMTOOLCREATE.hwndToolTips)
#End If
#If (WIN32_IE >= IE4) Then
        Case TTN_NEEDTEXTA, TTN_NEEDTEXTW ' or: TTN_GETDISPINFO?
          If CurLastToolTipButton = NMHDR.IdFrom Then
            Text = CurLastToolTip ' Strange, but this limits very much calls
          Else
            Set Button = ToolBar_GetItemFromID(CurhWnd, NMHDR.IdFrom)
            Text = Button.ToolTipText
            RaiseEvent ShowToolTip(Button, Text)
            CurLastToolTip = Text
          End If
          CurLastToolTipButton = NMHDR.IdFrom
          
          If (Len(Text) > 0) Then
            If NMHDR.code = TTN_NEEDTEXTA Then
              ReDim ByteStr(0 To Len(Text) - 1)
              ByteStr = StrConv(Text, vbFromUnicode)
            Else
              ReDim ByteStr(0 To LenB(Text) - 1)
              ByteStr = Text
            End If
            
            Call CopyMemory(NMTOOLTIP, ByVal lParam, LenB(NMTOOLTIP))
            Call CopyMemory(ByVal NMTOOLTIP.lpszText, ByteStr(0), UBound(ByteStr) + 1)
            Call CopyMemory(NMTOOLTIP.szText(0), ByteStr(0), UBound(ByteStr) + 1)
            Call CopyMemory(ByVal lParam, NMTOOLTIP, LenB(NMTOOLTIP))
          End If
          
          ' TOOLBAR NOTIFICATIONS!
          
'        Case TBN_GETINFOTIP
'          ' Get the tooltip text
'          I = SendMessage(CurhWnd, TB_COMMANDTOINDEX, NMHDR.IdFrom, ByVal 0)
'          If I > -1 Then
'            Set Button = Me.Buttons(I + 1)
'            Text = Button.ToolTipText
'            RaiseEvent ShowToolTip(Button, Text)
'          End If
'
'          ' Get the structure, and use the information of it.
'          Call CopyMemory(NMTBGETINFOTIP, ByVal lParam, LenB(NMTBGETINFOTIP))
'          If Len(Text) > NMTBGETINFOTIP.cchTextMax Then
'            Text = Left(Text, NMTBGETINFOTIP.cchTextMax)
'          Else
'            Text = Text & String(NMTBGETINFOTIP.cchTextMax - Len(Text), 0)
'          End If
'          Text = StrConv(Text, vbFromUnicode)
'
'          ' Now, let's change some characters in the memory block pointed by StrPtr(NMTBGETINFOTIP.pszText)
'          ' VB will automatically null-terminate strings and convert them to ANSI when you pass them byval.
'          ' (means: making a new string) the ByVal StrPtr() prevents that from happening
'          Call CopyMemory(ByVal NMTBGETINFOTIP.pszText, ByVal StrPtr(Text), LenB(Text))
'          Call CopyMemory(ByVal lParam, NMTBGETINFOTIP, LenB(NMTBGETINFOTIP))
        Case TBN_GETOBJECT:           Debug.Assert False
#End If
#If (WIN32_IE >= IE5) Then
        Case TBN_RESTORE, TBN_SAVE: Debug.Assert False
#End If
#If (WIN32_IE >= IE4) Then
        Case TBN_GETDISPINFO
          ReturnMessage = 0
          Call CopyMemory(NMDISPINFO, ByVal lParam, Len(NMDISPINFO))
          Allow = True
          RaiseEvent NeedButtonInfo(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMDISPINFO.idCommand), NMDISPINFO.dwMask, Text, I, Allow)
          If Not Allow Then NMDISPINFO.dwMask = NMDISPINFO.dwMask Or TBNF_DI_SETITEM
          If NMDISPINFO.dwMask And tbrNeedImage Then NMDISPINFO.iImage = I
          If NMDISPINFO.dwMask And tbrNeedText Then
            If Len(Text) > NMDISPINFO.cchText Then
              Text = Left(Text, NMDISPINFO.cchText)
            Else
              Text = Text & String(NMDISPINFO.cchText - Len(Text), 0)
            End If
            Text = StrConv(Text, vbFromUnicode)
            
            ' Now, let's change some characters in the memory block pointed by StrPtr(NMTBGETINFOTIP.pszText) again
            Call CopyMemory(ByVal NMDISPINFO.pszText, ByVal StrPtr(Text), LenB(Text))
          End If
          Call CopyMemory(ByVal lParam, NMDISPINFO, LenB(NMDISPINFO))
#End If
        Case TBN_GETBUTTONINFOA, TBN_GETBUTTONINFOW ' ???
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          If NMTBR.iItem < CurRemovedNum Then
            Text = Left(CurRemovedInfo(NMTBR.iItem) & String(NMTBR.cchText, 0), NMTBR.cchText)
            If NMHDR.code = TBN_GETBUTTONINFOA Then Text = StrConv(Text, vbFromUnicode)
            Call CopyMemory(ByVal NMTBR.pszText, ByVal StrPtr(Text), LenB(Text))
            Call CopyMemory(NMTBR.TBBUTTON, CurRemoved(NMTBR.iItem), LenB(NMTBR.TBBUTTON))
            Call CopyMemory(ByVal lParam, NMTBR, Len(NMTBR))
            ReturnMessage = 1
          Else
            ReturnMessage = 0
          End If
          Debug.Print ">> TBN_GETBUTTONINFO: " & NMTBR.iItem & ", " & GetStrFromPtr(NMTBR.pszText, NMTBR.cchText)
        Case TBN_BEGINDRAG
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          RaiseEvent ButtonDragInitialize(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem))
        Case TBN_ENDDRAG
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          RaiseEvent ButtonDragTerminate(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem))
        Case TBN_BEGINADJUST
          If NMHDR.IdFrom Then
            Set Button = ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHDR.IdFrom)
          Else
            Call ToolBar_ClearUp
          End If
          RaiseEvent CustomizeInitialize(Button)
        Case TBN_ENDADJUST
          If NMHDR.IdFrom Then Set Button = ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHDR.IdFrom)
          RaiseEvent CustomizeTerminate(Button)
        Case TBN_RESET
          RaiseEvent CustomizeReset
        Case TBN_QUERYINSERT
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          Allow = True
          RaiseEvent CustomizeQueryInsert(GetObjFromPtr(-NMTBR.TBBUTTON.dwData), NMTBR.iItem + 1, Allow)
          ReturnMessage = IIf(Allow, 1, 0)
        Case TBN_QUERYDELETE
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          Set Button = ToolBar_GetItem(NMHDR.hWndFrom, NMTBR.iItem)
          If Button Is Nothing Then Stop
          If NMTBR.iItem Then
            ' ToolBar_GetItem(NMHDR.hWndFrom, NMTBR.iItem)
          End If
          Allow = True
          RaiseEvent CustomizeQueryDelete(Button, Allow)
          ReturnMessage = IIf(Allow, 1, 0)
        Case TBN_TOOLBARCHANGE
          Call ToolBar_ClearUp
          RaiseEvent CustomizeChange
        Case TBN_CUSTHELP
          RaiseEvent CustomizeHelp
#If (WIN32_IE >= IE4) Then
        Case TBN_DROPDOWN
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          Set Button = ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem)
          'Call Me.Refresh
          RaiseEvent ButtonDropDown(Button, Button.Left, Button.Top + Button.Height + 2, ReturnMessage)
        Case TBN_HOTITEMCHANGE
          Call CopyMemory(NMHOTITEM, ByVal lParam, LenB(NMHOTITEM))
          Allow = True
          If NMHOTITEM.dwFlags And tbrHIEntering Then
            RaiseEvent HotItemChange(Nothing, ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idNew), NMHOTITEM.dwFlags, Allow)
          ElseIf NMHOTITEM.dwFlags And tbrHILeaving Then
            RaiseEvent HotItemChange(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idOld), Nothing, NMHOTITEM.dwFlags, Allow)
          Else
            RaiseEvent HotItemChange(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idOld), ToolBar_GetItemFromID(NMHDR.hWndFrom, NMHOTITEM.idNew), NMHOTITEM.dwFlags, Allow)
          End If
          ReturnMessage = IIf(Allow, 0, 1)
        Case TBN_DRAGOUT
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          RaiseEvent ButtonDragOut(ToolBar_GetItemFromID(NMHDR.hWndFrom, NMTBR.iItem))
        Case TBN_DELETINGBUTTON
          Call CopyMemory(NMTBR, ByVal lParam, Len(NMTBR))
          NMTBR.iItem = SendMessage(CurhWnd, TB_COMMANDTOINDEX, NMTBR.iItem, ByVal 0)
          NMTBR.TBBUTTON = ToolBarButton_Info(CurhWnd, NMTBR.iItem)
          Set Button = GetObjFromPtr(-NMTBR.TBBUTTON.dwData)
          If Not Button Is Nothing Then
            Dim VBCol As Collection
            RaiseEvent ButtonDeleting(Button)
            Call Button.ToolBarButton_Available(False)
            CurRemovedNum = CurRemovedNum + 1
            If CurRemovedNum = 1 Then
              ReDim CurRemoved(0 To CurRemovedNum - 1) As TBBUTTON
              ReDim CurRemovedInfo(0 To CurRemovedNum - 1) As String
            Else
              ReDim Preserve CurRemoved(0 To CurRemovedNum - 1) As TBBUTTON
              ReDim Preserve CurRemovedInfo(0 To CurRemovedNum - 1) As String
            End If
            
            LSet CurRemoved(CurRemovedNum - 1) = NMTBR.TBBUTTON
            CurRemovedInfo(CurRemovedNum - 1) = IIf(Len(Button.Caption), Button.Caption, Button.Description)
            
'           Set VBCol = GetObjFromPtr(-GetProp(CurhWnd, TBR_PROP_BUTTONSCOL))
'           If Not VBCol Is Nothing Then
'             On Error Resume Next
'               Call VBCol.Remove("ButtonCls=" & ObjPtr(Button))
'               If Err.Number Then Debug.Print "Button not in collection!"
'             On Error GoTo 0
'           End If
          Else
            ReturnMessage = evtHandled ' No recursion from here.
            ' This event is property a result of a new added
            ' button we don't know about. Right now, the button
            ' is replaced by one with object reference in the dwData member.
          End If
#End If
#If (WIN32_IE >= IE5) Then
        Case TBN_INITCUSTOMIZE
          Allow = True
          RaiseEvent CustomizeShowDlg(Allow)
          If Not Allow Then ReturnMessage = TBNRF_HIDEHELP
#End If
        Case Else
'          Debug.Print "NOTIFICATION_???   from: " & NMHDR.hWndFrom & "[" & NMHDR.IdFrom & "] code: " & NMHDR.code
      End Select
  End Select
End Sub

'===========================================================


'-----------------------------------------------------------
' Class Interface

Private Sub UserControl_Initialize()
  Dim InitCCEx As tagInitCommonControlsEx
  InitCCEx.lngSize = LenB(InitCCEx)
  InitCCEx.lngICC = ICC_BAR_CLASSES
  Call InitCommonControlsEx(InitCCEx)
  Set CurBitmaps = New Collection
End Sub

Private Sub UserControl_InitProperties()
  Call ToolBar_Create
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  If CurhWnd = 0 Then Call ToolBar_Create
  #If Not DISALLOW_CUSTOMIZEPROP Then
    Me.Ajustable = PropBag.ReadProperty("Ajustable", tbrShiftDrag)
  #End If
#If (WIN32_IE >= IE4) Then
  Me.AnchorHighlight = PropBag.ReadProperty("AnchorHighlight", False)
  Me.BackColor = PropBag.ReadProperty("BackColor", vbButtonFace)
  Me.CustomButtonColors = PropBag.ReadProperty("CustomButtonColors", False)
  If Me.CustomButtonColors Then
    Me.ButtonHighlightColor = PropBag.ReadProperty("ButtonHighlightColor", CLR_LIGHT_BORDER)
    Me.ButtonShadowColor = PropBag.ReadProperty("ButtonShadowColor", CLR_SHADOW_BORDER)
  End If
#End If
  Me.Divider = PropBag.ReadProperty("Divider", False)
  Me.Flat = PropBag.ReadProperty("Flat", True)
  Me.List = PropBag.ReadProperty("List", False)
  Me.Enabled = PropBag.ReadProperty("Enabled", True)
#If (WIN32_IE >= IE4) Then
  Me.PaddingWidth = PropBag.ReadProperty("PaddingWidth", 7)
  Me.PaddingHeight = PropBag.ReadProperty("PaddingHeight", 6)
  Me.ShowDropArrows = PropBag.ReadProperty("ShowDropArrows", True)
#End If
  Me.SmartResize = PropBag.ReadProperty("SmartResize", False)
  Me.TextRows = PropBag.ReadProperty("TextRows", 1)
#If (WIN32_IE >= IE4) Then
  Me.UseBackground = PropBag.ReadProperty("UseBackground", True)
#End If
  Me.UseToolTips = PropBag.ReadProperty("UseToolTips", True)
  Me.Wrappable = PropBag.ReadProperty("Wrappable", True)
  Me.ButtonWidth = PropBag.ReadProperty("ButtonWidth", 23)
  Me.ButtonHeight = PropBag.ReadProperty("ButtonHeight", 21)
End Sub

Private Sub UserControl_Show()
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_SHOWWINDOW)
End Sub

Private Sub UserControl_Hide()
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_HIDEWINDOW)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  #If Not DISALLOW_CUSTOMIZEPROP Then
    Call PropBag.WriteProperty("Ajustable", Me.Ajustable, tbrNotAjustable) ' tbrShiftDrag
  #End If
#If (WIN32_IE >= IE4) Then
  Call PropBag.WriteProperty("AnchorHighlight", Me.AnchorHighlight, False)
  Call PropBag.WriteProperty("BackColor", Me.BackColor, vbButtonFace)
#End If
  Call PropBag.WriteProperty("ButtonWidth", Me.ButtonWidth, 23)
  Call PropBag.WriteProperty("ButtonHeight", Me.ButtonHeight, 21)
#If (WIN32_IE >= IE4) Then
  Call PropBag.WriteProperty("CustomButtonColors", Me.CustomButtonColors, False)
  Call PropBag.WriteProperty("ButtonHighlightColor", Me.ButtonHighlightColor, CLR_LIGHT_BORDER)
  Call PropBag.WriteProperty("ButtonShadowColor", Me.ButtonShadowColor, CLR_SHADOW_BORDER)
#End If
  Call PropBag.WriteProperty("Enabled", Me.Enabled, True)
  Call PropBag.WriteProperty("Divider", Me.Divider, False)
  Call PropBag.WriteProperty("Flat", Me.Flat, True)
  Call PropBag.WriteProperty("List", Me.List, False)
#If (WIN32_IE >= IE4) Then
  Call PropBag.WriteProperty("PaddingHeight", Me.PaddingHeight, 6)
  Call PropBag.WriteProperty("PaddingWidth", Me.PaddingWidth, 7)
  Call PropBag.WriteProperty("ShowDropArrows", Me.ShowDropArrows, True)
#End If
  Call PropBag.WriteProperty("SmartResize", Me.SmartResize, False)
  Call PropBag.WriteProperty("TextRows", Me.TextRows, 1)
#If (WIN32_IE >= IE4) Then
  Call PropBag.WriteProperty("UseBackground", Me.UseBackground, True)
#End If
  Call PropBag.WriteProperty("UseToolTips", Me.UseToolTips, True)
  Call PropBag.WriteProperty("Wrappable", Me.Wrappable, True)
End Sub

Public Property Get Left() As Long
Attribute Left.VB_Description = "Returns the left position of the toolbar."
  Dim rctTbr As RECT
  Dim rctCtl As RECT
  Call GetClientRect(UserControl.hWnd, rctCtl)
  Call GetClientRect(CurhWnd, rctTbr)
  Left = rctCtl.Left
End Property

Public Property Get Top() As Long
Attribute Top.VB_Description = "Returns the top position of the toolbar."
  Dim rctTbr As RECT
  Dim rctCtl As RECT
  Call GetClientRect(UserControl.hWnd, rctCtl)
  Call GetClientRect(CurhWnd, rctTbr)
  Top = rctCtl.Top
End Property

Private Sub UserControl_Resize()
  If Not CurResizing And CurhWnd <> 0 Then
    CurResizing = True ' Avoid recursive calls from usercontrol's winproc
    
    Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, UserControl.ScaleHeight, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER)
    
    If CurSmartResize Then
      UserControl.Width = UserControl.ScaleX(Me.ContentWidth, vbPixels, vbTwips) + (UserControl.Width - UserControl.ScaleX(UserControl.ScaleWidth, UserControl.ScaleMode, vbTwips))
      UserControl.Height = UserControl.ScaleY(Me.ContentHeight, vbPixels, vbTwips) + (UserControl.Height - UserControl.ScaleY(UserControl.ScaleHeight, UserControl.ScaleMode, vbTwips))
      Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, UserControl.ScaleWidth, UserControl.ScaleHeight, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER)
    Else
      Call SetWindowPos(CurhWnd, 0, UserControl.ScaleLeft, UserControl.ScaleTop, Me.ContentWidth, Me.ContentHeight, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER)
    End If
    
    CurResizing = False
  End If
End Sub

Private Sub UserControl_Terminate()
  If EventHandler.Attached(UserControl.hWnd) Then EventHandler.Attached(UserControl.hWnd) = False
  On Error Resume Next
    Set CurImageList = Nothing
    Set CurHotImageList = Nothing
    Set CurDisabledImageList = Nothing
  On Error GoTo 0
  Set TB_Buttons = Nothing
  Call DestroyWindow(CurhWnd)
  CurhWnd = 0
End Sub


'===========================================================


'----------------------------------------------------------
' hWnd

Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns the handle to the toolbar window itself."
'  hWnd = UserControl.hWnd
  hWnd = CurhWnd
End Property

Public Property Get ImageList() As ImageListCore.ImageList
Attribute ImageList.VB_Description = "Contains the default button images."
  Dim himl As OLE_HANDLE
  himl = SendMessage(CurhWnd, TB_GETIMAGELIST, 0, ByVal 0)
  If himl = 0 Then
    Set CurImageList = Nothing
  Else
    If CurImageList Is Nothing Then
      Set CurImageList = ImageListCore.ImageListAttach(himl, , True)
    ElseIf CurImageList.hImageList <> himl Then
      Set CurImageList = ImageListCore.ImageListAttach(himl, , True)
    End If
    Set ImageList = CurImageList
  End If
End Property

Public Property Let ImageList(ByVal NewValue As ImageListCore.ImageList)
  Set ImageList = NewValue
End Property

Public Property Set ImageList(ByVal NewValue As ImageListCore.ImageList)
  If Not NewValue Is Nothing Then
    If Not TypeOf NewValue Is ImageListCore.ImageList Then Error 380
    Call SendMessage(CurhWnd, TB_SETIMAGELIST, 0, ByVal NewValue.hImageList)
  Else
    Call SendMessage(CurhWnd, TB_SETIMAGELIST, 0, ByVal 0)
  End If
  Set CurImageList = NewValue
End Property

Public Property Get DisabledImageList() As ImageListCore.ImageList
Attribute DisabledImageList.VB_Description = "Contains the image list used for disabled buttons. "
  Dim himl As OLE_HANDLE
  himl = SendMessage(CurhWnd, TB_GETDISABLEDIMAGELIST, 0, ByVal 0)
  If himl = 0 Then
    Set CurDisabledImageList = Nothing
  Else
    If CurDisabledImageList Is Nothing Then
      Set CurDisabledImageList = ImageListCore.ImageListAttach(himl, , True)
    ElseIf CurDisabledImageList.hImageList <> himl Then
      Set CurDisabledImageList = ImageListCore.ImageListAttach(himl, , True)
    End If
    Set DisabledImageList = CurDisabledImageList
  End If
End Property

Public Property Let DisabledImageList(ByVal NewValue As ImageListCore.ImageList)
  Set ImageList = NewValue
End Property

Public Property Set DisabledImageList(ByVal NewValue As ImageListCore.ImageList)
  If Not NewValue Is Nothing Then
    If Not TypeOf NewValue Is ImageListCore.ImageList Then Error 380
    Call SendMessage(CurhWnd, TB_SETDISABLEDIMAGELIST, 0, ByVal NewValue.hImageList)
  Else
    Call SendMessage(CurhWnd, TB_SETDISABLEDIMAGELIST, 0, ByVal 0)
  End If
  Set CurDisabledImageList = NewValue
End Property

Public Property Get HotImageList() As ImageListCore.ImageList
Attribute HotImageList.VB_Description = "Contains the image used for selected buttons."
  Dim himl As OLE_HANDLE
  himl = SendMessage(CurhWnd, TB_GETIMAGELIST, 0, ByVal 0)
  If himl = 0 Then
    Set CurHotImageList = Nothing
  Else
    If CurHotImageList Is Nothing Then
      Set CurHotImageList = ImageListCore.ImageListAttach(himl, , True)
    ElseIf CurHotImageList.hImageList <> himl Then
      Set CurHotImageList = ImageListCore.ImageListAttach(himl, , True)
    End If
    Set HotImageList = CurHotImageList
  End If
End Property

Public Property Let HotImageList(ByVal NewValue As ImageListCore.ImageList)
  Set HotImageList = NewValue
End Property

Public Property Set HotImageList(ByVal NewValue As ImageListCore.ImageList)
  If Not NewValue Is Nothing Then
    If Not TypeOf NewValue Is ImageListCore.ImageList Then Error 380
    Call SendMessage(CurhWnd, TB_SETHOTIMAGELIST, 0, ByVal NewValue.hImageList)
  Else
    Call SendMessage(CurhWnd, TB_SETHOTIMAGELIST, 0, ByVal 0)
  End If
  Set CurHotImageList = NewValue
End Property

Public Property Get hWndTooltip() As OLE_HANDLE
Attribute hWndTooltip.VB_Description = "Returns the window handle to the tooltip used."
Attribute hWndTooltip.VB_MemberFlags = "400"
  hWndTooltip = SendMessage(CurhWnd, TB_GETTOOLTIPS, 0, ByVal 0)
End Property

Public Property Let hWndTooltip(NewValue As OLE_HANDLE)
  If IsWindow(NewValue) = 0 And NewValue <> 0 Then Error 380
  Call SendMessage(CurhWnd, TB_SETTOOLTIPS, NewValue, ByVal 0)
  PropertyChanged
End Property

Public Sub AboutBox()
Attribute AboutBox.VB_Description = "Displays an about dialog box"
Attribute AboutBox.VB_UserMemId = -552
Attribute AboutBox.VB_MemberFlags = "40"
  frmAbout.Show vbModal
End Sub

'----------------------------------------------------------
' Buttons

Public Property Get Buttons() As ToolBarButtons
Attribute Buttons.VB_Description = "Contains the buttons for of the toolbar."
  Set Buttons = TB_Buttons
End Property

Public Function HitTest(PtX As Long, PtY As Long, Optional ReturnNearest As Boolean, Optional NearestReturnPtr As Boolean) As ToolBarButton
Attribute HitTest.VB_Description = "Tells you which button is located under a certain position."
  Dim Pos As Long
  Dim Coord As POINTAPI
  Coord.X = PtX
  Coord.Y = PtY
  Pos = SendMessage(CurhWnd, TB_HITTEST, 0, Coord)
  If ReturnNearest Then
    NearestReturnPtr = (Pos >= 0) ' Returned nearest when pos is neg
    Pos = Abs(Pos)
  End If
  If Pos >= 0 And Pos < SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) Then
    Set HitTest = ToolBar_GetItem(CurhWnd, Pos)
  End If
End Function

#If (WIN32_IE >= IE4) Then
  Public Function MapAccelerator(KeyCode As Long) As ToolBarButton
Attribute MapAccelerator.VB_Description = "Converts a accelerator key into a toolbar button."
    Dim Pos As Long
    If SendMessage(CurhWnd, TB_MAPACCELERATOR, KeyCode, Pos) <> 0 Then
      Set MapAccelerator = ToolBar_GetItemFromID(CurhWnd, Pos)
    End If
  End Function
#End If

Public Function LoadButtonImageList(DefaultImageList As TbrImageLists) As Long
Attribute LoadButtonImageList.VB_Description = "Loads default images to the button's imagelist."
  If DefaultImageList = tbrIconStandardLargeColor Or DefaultImageList = tbrIconViewLargeColor Or DefaultImageList = tbrIconHistoryLargeColor Then
    Call Me.SetButtonImageSize(24, 24)
  Else
    Call Me.SetButtonImageSize(16, 15)
  End If
  LoadButtonImageList = SendMessage(CurhWnd, TB_LOADIMAGES, DefaultImageList, ByVal HINST_COMMCTRL)
End Function

' Add the bitmap containing button images to the toolbar.
Public Function LoadButtonsBitmap(Bitmap As IPicture, Optional hAppInstance As Long, Optional ByVal NumButtons As Long = -1)
Attribute LoadButtonsBitmap.VB_Description = "Loads a bitmap into the toolbar's button image list."
  If Not (TypeOf Bitmap Is StdPicture Or TypeOf Bitmap Is IPicture Or TypeOf Bitmap Is IPictureDisp) Then Error 5
  Dim TbrBmp As TBADDBITMAP
  TbrBmp.hInst = hAppInstance
  TbrBmp.nID = Bitmap.Handle
  LoadButtonsBitmap = SendMessage(CurhWnd, TB_ADDBITMAP, NumButtons, TbrBmp)
  If LoadButtonsBitmap = -1 Then Error 5
  
  Call CurBitmaps.Add(Bitmap, "C" & Bitmap.Handle)
End Function

Public Sub ReplaceButtonsBitmap(OldBitmap As IPicture, ReplaceBitmap As IPicture, Optional hAppInstanceOld As Long, Optional hAppInstanceNew As Long, Optional ByVal NumButtons As Long = -1)
Attribute ReplaceButtonsBitmap.VB_Description = "Replaces a certain bitmap in the image list by an other one."
  Dim TbrNewBmp As TBREPLACEBITMAP
  TbrNewBmp.nButtons = NumButtons
  TbrNewBmp.hInstOld = hAppInstanceOld
  TbrNewBmp.hInstNew = hAppInstanceNew
  TbrNewBmp.nIDOld = OldBitmap.Handle
  If Not ReplaceBitmap Is Nothing Then TbrNewBmp.nIDNew = ReplaceBitmap.Handle
  If SendMessage(CurhWnd, TB_REPLACEBITMAP, 0, TbrNewBmp) = 0 Then Error 5
  Call CurBitmaps.Remove("C" & OldBitmap.Handle)
  Call CurBitmaps.Add(ReplaceBitmap, "C" & ReplaceBitmap.Handle)
End Sub


Public Sub SetButtonImageSize(Optional Width As Long = 16, Optional Height As Long = 15)
Attribute SetButtonImageSize.VB_Description = "Sets the size used for button images."
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD.LoWord = Width
  DWORD.HiWord = Height
  LSet DWORD_LONG = DWORD
  If SendMessage(CurhWnd, TB_SETBITMAPSIZE, 0, ByVal DWORD_LONG.N) = 0 Then Error 5
End Sub

Public Sub SetButtonSize(Optional LargeButtons As Boolean = False, Optional WithText As Boolean = False)
Attribute SetButtonSize.VB_Description = "Sets the size of the buttons."
  If Not LargeButtons Then
    Call Me.SetButtonSizeEx(16, IIf(WithText, 14, 15))
  Else
    If Not WithText Then
      Call Me.SetButtonSizeEx(32, 32)
    Else
      Call Me.SetButtonSizeEx(50, 50)
    End If
  End If
End Sub

Public Sub SetButtonSizeEx(Optional Width As Integer = 24, Optional Height As Integer = 22)
Attribute SetButtonSizeEx.VB_Description = "Sets the exact size used for buttons."
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD.LoWord = Width
  DWORD.HiWord = Height
  LSet DWORD_LONG = DWORD
  If SendMessage(CurhWnd, TB_SETBUTTONSIZE, 0, ByVal DWORD_LONG.N) = 0 Then Error 5
  Call ToolBar_Update(CurhWnd, CurRunMode)
End Sub

Public Property Get ButtonWidth() As Integer
Attribute ButtonWidth.VB_Description = "Specifies the width of each button."
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD_LONG.N = SendMessage(CurhWnd, TB_GETBUTTONSIZE, 0, ByVal 0)
  LSet DWORD = DWORD_LONG
  ButtonWidth = DWORD.LoWord
End Property

Public Property Let ButtonWidth(NewValue As Integer)
  Call Me.SetButtonSizeEx(NewValue, Me.ButtonHeight)
  PropertyChanged "ButtonWidth"
End Property

Public Property Get ButtonHeight() As Integer
Attribute ButtonHeight.VB_Description = "Returns the current button's height."
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD_LONG.N = SendMessage(CurhWnd, TB_GETBUTTONSIZE, 0, ByVal 0)
  LSet DWORD = DWORD_LONG
  ButtonHeight = DWORD.HiWord
End Property

Public Property Let ButtonHeight(NewValue As Integer)
  Call Me.SetButtonSizeEx(Me.ButtonWidth, NewValue)
  PropertyChanged "ButtonHeight"
End Property

Public Sub SetButtonMMWidth(MinWidth As Long, MaxWidth As Long)
Attribute SetButtonMMWidth.VB_Description = "Sets the min/max width of toolbar buttons."
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD.LoWord = MinWidth
  DWORD.HiWord = MaxWidth
  LSet DWORD_LONG = DWORD
  If SendMessage(CurhWnd, TB_SETBUTTONWIDTH, 0, ByVal DWORD_LONG.N) = 0 Then Error 5
End Sub

#If (WIN32_IE >= IE4) Then
  Public Property Get CustomButtonColors() As Boolean
Attribute CustomButtonColors.VB_Description = "True when custom button colors are used."
    CustomButtonColors = CurUseCustomColors
  End Property
  
  Public Property Let CustomButtonColors(NewValue As Boolean)
    CurUseCustomColors = NewValue
    Dim Colors As COLORSCHEME
    Colors.dwSize = LenB(Colors)
    If NewValue = False Then
      Colors.clrBtnHighlight = tbrColorDefault
      Colors.clrBtnShadow = tbrColorDefault
    Else
      Colors.clrBtnHighlight = CoolBar_CColor(CLR_LIGHT_BORDER)
      Colors.clrBtnShadow = CoolBar_CColor(CLR_SHADOW_BORDER)
    End If
    CurButtonHighlight = CLR_LIGHT_BORDER
    CurButtonShadow = CLR_SHADOW_BORDER
    CommonControls_ColorScheme(CurhWnd) = Colors
    PropertyChanged "CustomButtonColors"
  End Property
  
  Public Property Get ButtonHighlightColor() As OLE_COLOR
Attribute ButtonHighlightColor.VB_Description = "Specifies a custom light border color for each button."
    ButtonHighlightColor = CommonControls_ColorScheme(CurhWnd).clrBtnHighlight
    If ButtonHighlightColor = CoolBar_CColor(CurButtonHighlight) Then ButtonHighlightColor = CurButtonHighlight
    If ButtonHighlightColor = tbrColorDefault And Not CurUseCustomColors Then ButtonHighlightColor = CLR_LIGHT_BORDER
  End Property
  
  Public Property Let ButtonHighlightColor(NewValue As OLE_COLOR)
    If Not CurUseCustomColors Then Error 383
    Dim Colors As COLORSCHEME
    Colors = CommonControls_ColorScheme(CurhWnd)
    If NewValue <> tbrColorDefault Then
      Colors.clrBtnHighlight = CoolBar_CColor(NewValue)
      If Colors.clrBtnHighlight = -1 Then Error 380
    Else
      Colors.clrBtnHighlight = NewValue
    End If
    CommonControls_ColorScheme(CurhWnd) = Colors
    PropertyChanged "ButtonHighlightColor"
  End Property
  
  Public Property Get ButtonShadowColor() As OLE_COLOR
Attribute ButtonShadowColor.VB_Description = "Specifies a custom dark border color for each button."
    ButtonShadowColor = CommonControls_ColorScheme(CurhWnd).clrBtnShadow
    If ButtonShadowColor = CoolBar_CColor(CurButtonShadow) Then ButtonShadowColor = CurButtonShadow
    If ButtonShadowColor = tbrColorDefault And Not CurUseCustomColors Then ButtonShadowColor = CLR_SHADOW_BORDER
  End Property
  
  Public Property Let ButtonShadowColor(NewValue As OLE_COLOR)
    If Not CurUseCustomColors Then Error 383
    Dim Colors As COLORSCHEME
    Colors = CommonControls_ColorScheme(CurhWnd)
    If NewValue <> tbrColorDefault Then
      Colors.clrBtnShadow = CoolBar_CColor(NewValue)
      If Colors.clrBtnShadow = -1 Then Error 380
    Else
      Colors.clrBtnShadow = NewValue
    End If
    CommonControls_ColorScheme(CurhWnd) = Colors
    PropertyChanged "ButtonShadowColor"
  End Property
  
  Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns the background color of the toolbar."
    BackColor = UserControl.BackColor
  End Property
  
  Public Property Let BackColor(NewValue As OLE_COLOR)
    UserControl.BackColor = NewValue
    PropertyChanged "BackColor"
  End Property
#End If



'----------------------------------------------------------
' TextRows

Public Property Get TextRows() As Long
Attribute TextRows.VB_Description = "Retrurns/Sets the number of text rows drawn on a button. Zero is also supported."
  TextRows = SendMessage(CurhWnd, TB_GETTEXTROWS, 0, ByVal 0)
End Property

Public Property Let TextRows(NewValue As Long)
  If SendMessage(CurhWnd, TB_SETMAXTEXTROWS, NewValue, ByVal 0) = 0 Then Error 380
  Call ToolBar_Update(CurhWnd, CurRunMode)
  PropertyChanged "TextRows"
End Property

'----------------------------------------------------------
' Subs

Public Sub AutoSize()
Attribute AutoSize.VB_Description = "Autosizes the toolbar."
  Call SendMessage(CurhWnd, TB_AUTOSIZE, 0, ByVal 0)
End Sub

Public Property Get SmartResize() As Boolean
Attribute SmartResize.VB_Description = "Affects the resing behavour of the toolbar."
  SmartResize = CurSmartResize
End Property

Public Property Let SmartResize(NewValue As Boolean)
  CurSmartResize = NewValue
  Call UserControl_Resize
  PropertyChanged "SmartResize"
End Property

Public Sub Customize()
Attribute Customize.VB_Description = "Displays the customize dialog box."
Attribute Customize.VB_MemberFlags = "40"
  Call SendMessage(CurhWnd, TB_CUSTOMIZE, 0, ByVal 0)
End Sub

Public Sub SaveSettings(HKEY As RegHKEYConstants, SubKeyName As String, Value As String)
Attribute SaveSettings.VB_Description = "Saves the toolbar buttons settings."
  Dim Settings As TBSAVEPARAMS
  Settings.HKEY = HKEY
  Settings.pszSubKey = VarPtr(SubKeyName)
  Settings.pszValueName = VarPtr(Value)
  Call SendMessage(CurhWnd, TB_SAVERESTORE, 1, Settings)
End Sub

Public Sub RestoreSettings(HKEY As RegHKEYConstants, SubKeyName As String, Value As String)
Attribute RestoreSettings.VB_Description = "Occures when the settings of the toolbar are restored."
  Dim Settings As TBSAVEPARAMS
  Settings.HKEY = HKEY
  Settings.pszSubKey = VarPtr(SubKeyName)
  Settings.pszValueName = VarPtr(Value)
  Call SendMessage(CurhWnd, TB_SAVERESTORE, 0, Settings)
End Sub

Public Property Get ButtonDrawTextFlags(Optional MaskBits As TbrButtonTextFlags = &HFFFFFFFF) As TbrButtonTextFlags
Attribute ButtonDrawTextFlags.VB_Description = "Specifies how the button's text is drawn."
  ButtonDrawTextFlags = SendMessage(CurhWnd, TB_SETDRAWTEXTFLAGS, 0, ByVal 0)
End Property

Public Property Let ButtonDrawTextFlags(Optional MaskBits As TbrButtonTextFlags = &HFFFFFFFF, NewValue As TbrButtonTextFlags)
  Call SendMessage(CurhWnd, TB_SETDRAWTEXTFLAGS, MaskBits, ByVal NewValue)
End Property

Public Property Let ButtonIndent(NewValue As Long)
Attribute ButtonIndent.VB_Description = "Indents the buttons."
  If SendMessage(CurhWnd, TB_SETINDENT, NewValue, ByVal 0) = 0 Then Error 380
End Property

' Wich type of bitmaps (size) to use?
Public Property Get BitmapFlags() As TbrBitmapFlags
Attribute BitmapFlags.VB_Description = "Returns the flags for the current loaded bitmaps in the toolbar."
  BitmapFlags = SendMessage(CurhWnd, TB_GETBITMAPFLAGS, 0, ByVal 0)
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get AnchorHighlight() As Boolean
Attribute AnchorHighlight.VB_Description = "Keeps highliting a button if the user moves the mouse to a other window."
    AnchorHighlight = SendMessage(CurhWnd, TB_GETANCHORHIGHLIGHT, 0, ByVal 0)
  End Property
  
  Public Property Let AnchorHighlight(NewValue As Boolean)
    Call SendMessage(CurhWnd, TB_SETANCHORHIGHLIGHT, CLng(CByte(NewValue)), ByVal 0)
  End Property
#End If

#If (WIN32_IE >= IE4) Then
  Public Property Get HotButton() As ToolBarButton
Attribute HotButton.VB_Description = "Contains the button which is currenty selected."
    Dim HotItem As Long
    HotItem = SendMessage(CurhWnd, TB_GETHOTITEM, 0, ByVal 0)
    If HotItem = -1 Then Exit Property
    Set HotButton = ToolBar_GetItem(CurhWnd, HotItem)
  End Property
  
  Public Property Let HotButton(NewValue As ToolBarButton)
    If NewValue Is Nothing Then
      Call SendMessage(CurhWnd, TB_SETHOTITEM, -1, ByVal 0)
    Else
      If Not TypeOf NewValue Is ToolBarButton Then Error 380
      Call SendMessage(CurhWnd, TB_SETHOTITEM, NewValue.Index - 1, ByVal 0)
    End If
  End Property
#End If

Public Property Get ContentWidth() As Long
Attribute ContentWidth.VB_Description = "Specifies the height of the contained buttons."
  Dim rctButton As RECT
  Dim rctTotal As RECT
  Dim I As Long
  
  For I = 0 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) - 1
    If SendMessage(CurhWnd, TB_GETITEMRECT, I, rctButton) <> 0 Then
      If UnionRect(rctTotal, rctTotal, rctButton) = 0 Then Error 5
    End If
  Next
  ContentWidth = rctTotal.Right + 2 * rctTotal.Left ' BORDER
End Property

Public Property Get ContentHeight() As Long
Attribute ContentHeight.VB_Description = "Specifies the height of the contained buttons."
  Dim rctButton As RECT
  Dim rctTotal As RECT
  Dim I As Long
  
  For I = 0 To SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) - 1
    If SendMessage(CurhWnd, TB_GETITEMRECT, I, rctButton) <> 0 Then
      If UnionRect(rctTotal, rctTotal, rctButton) = 0 Then Error 5
    End If
  Next
  ContentHeight = rctTotal.Bottom - rctTotal.Top + 2 * rctTotal.Top  ' BORDER
#If (WIN32_IE >= IE4) Then
  On Error Resume Next
    I = Me.MaxContentHeight
  On Error GoTo 0
  If ContentHeight < I Then ContentHeight = I
#End If
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get MaxContentWidth() As Long
Attribute MaxContentWidth.VB_Description = "Defines the maximum context width used for the toolbar contents."
    Dim SIZE As SIZE
    If SendMessage(CurhWnd, TB_GETMAXSIZE, 0, SIZE) = 0 Then Error 5
    MaxContentWidth = SIZE.cx
  End Property
  
  Public Property Get MaxContentHeight() As Long
Attribute MaxContentHeight.VB_Description = "Defines the maximum context height used for the toolbar contents."
    Dim SIZE As SIZE
    If SendMessage(CurhWnd, TB_GETMAXSIZE, 0, SIZE) = 0 Then Error 5
    MaxContentHeight = SIZE.cy
  End Property
  
  Public Sub SetPadding(Width As Integer, Height As Integer)
Attribute SetPadding.VB_Description = "Sets the button padding."
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD.LoWord = Width
    DWORD.HiWord = Height
    LSet DWORD_LONG = DWORD
    Call SendMessage(CurhWnd, TB_SETPADDING, 0, ByVal DWORD_LONG.N)
    Call ToolBar_Update(CurhWnd, CurRunMode)
  End Sub
  
  Public Property Get PaddingWidth() As Integer
Attribute PaddingWidth.VB_Description = "Returns/Sets the padding width for the buttons."
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD_LONG.N = SendMessage(CurhWnd, TB_GETPADDING, 0, ByVal 0)
    LSet DWORD = DWORD_LONG
    PaddingWidth = DWORD.LoWord
  End Property
  
  Public Property Let PaddingWidth(NewValue As Integer)
    Call Me.SetPadding(NewValue, Me.PaddingHeight)
    PropertyChanged "PaddingWidth"
  End Property
  
  Public Property Get PaddingHeight() As Integer
Attribute PaddingHeight.VB_Description = "Returns/Sets the padding height for the buttons."
    Dim DWORD As DWORD
    Dim DWORD_LONG As DWORD_LONG
    DWORD_LONG.N = SendMessage(CurhWnd, TB_GETPADDING, 0, ByVal 0)
    LSet DWORD = DWORD_LONG
    PaddingHeight = DWORD.HiWord
  End Property
  
  Public Property Let PaddingHeight(NewValue As Integer)
    Call Me.SetPadding(Me.PaddingWidth, NewValue)
    PropertyChanged "PaddingHeight"
  End Property
#End If

Public Property Get ButtonRows(Optional AllowMoreWhenNotFit As Boolean = True) As Long
Attribute ButtonRows.VB_Description = "Specifies how many rows are used when wrappable."
  If AllowMoreWhenNotFit = False Then Error 5
  ButtonRows = SendMessage(CurhWnd, TB_GETROWS, 0, ByVal 0)
End Property

Public Property Let ButtonRows(Optional AllowMoreWhenNotFit As Boolean = True, NewValue As Long)
  Dim NewRect As RECT
  Dim DWORD As DWORD
  Dim DWORD_LONG As DWORD_LONG
  DWORD.LoWord = CInt(NewValue)
  DWORD.HiWord = CInt(CByte(AllowMoreWhenNotFit))
  LSet DWORD_LONG = DWORD
  If NewValue < 0 Or NewValue > SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0) Then Error 380
  Call SendMessage(CurhWnd, TB_SETROWS, DWORD_LONG.N, NewRect)
End Property


'----------------------------------------------------------
' Window Style Flags

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "True if the toolbar can respond to user-generated events."
  Enabled = IsWindowEnabled(CurhWnd)
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
  Call EnableWindow(CurhWnd, IIf(NewValue, 1, 0))
  UserControl.Enabled = NewValue
End Property

Public Property Get UseToolTips() As Boolean
Attribute UseToolTips.VB_Description = "Specifies if tooltips are used or not."
  UseToolTips = (SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_TOOLTIPS)
End Property

Public Property Let UseToolTips(NewValue As Boolean)
  Call ToolBar_StyleMod(CurhWnd, TBSTYLE_TOOLTIPS, NewValue)
  Call ToolBar_Update(CurhWnd, CurRunMode)
  PropertyChanged "UseToolTips"
End Property

Public Property Get Wrappable() As Boolean
Attribute Wrappable.VB_Description = "Makes buttons wrap if the don't fit at the end of the button's row."
  Wrappable = (SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_WRAPABLE)
End Property

Public Property Let Wrappable(NewValue As Boolean)
  Dim ButtonSize As Long
  ButtonSize = SendMessage(CurhWnd, TB_GETBUTTONSIZE, 0, ByVal 0)
  Call ToolBar_StyleMod(CurhWnd, TBSTYLE_WRAPABLE, NewValue)
  If SendMessage(CurhWnd, TB_SETBUTTONSIZE, 0, ByVal ButtonSize) = 0 Then Error 5
  Call ToolBar_Update(CurhWnd, CurRunMode)
  PropertyChanged "Wrappable"
End Property

Public Property Get Flat() As Boolean
Attribute Flat.VB_Description = "If True, no borders will be displayed around buttons, unless the mouse hovers over it."
  Flat = (SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_FLAT)
End Property

Public Property Let Flat(NewValue As Boolean)
  Dim rctTbr As RECT
  Dim Visible As Boolean
  Visible = IsWindowVisible(CurhWnd) <> 0
  If Visible Then
    Call LockWindowUpdate(CurhWnd)
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_HIDEWINDOW)
  End If
  Call ToolBar_StyleMod(CurhWnd, TBSTYLE_FLAT, NewValue)
  If Visible Then
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW)
    Call LockWindowUpdate(0)
  End If
  DoEvents
  CurResizing = True
    Call GetClientRect(CurhWnd, rctTbr)
    UserControl.Height = UserControl.ScaleY(rctTbr.Bottom - rctTbr.Top, vbPixels, vbTwips) + (UserControl.Height - UserControl.ScaleY(UserControl.ScaleHeight, UserControl.ScaleMode, vbTwips))
  CurResizing = False
  PropertyChanged "Flat"
End Property

Public Property Get List() As Boolean
Attribute List.VB_Description = "Specifies how the toolbar buttons will be displayed. (Like buttons, or as a links-list)."
  List = (SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_LIST)
End Property

Public Property Let List(NewValue As Boolean)
  Call ToolBar_StyleMod(CurhWnd, TBSTYLE_LIST, NewValue)
  Call ToolBar_Update(CurhWnd, CurRunMode)
  PropertyChanged "List"
End Property

#If (WIN32_IE >= IE4) Then
  Public Property Get UseBackground() As Boolean
Attribute UseBackground.VB_Description = "Makes the toolbar transparent if true."
    UseBackground = (SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_TRANSPARENT)
  End Property
  
  Public Property Let UseBackground(NewValue As Boolean)
    Call ToolBar_StyleMod(CurhWnd, TBSTYLE_TRANSPARENT, NewValue)
    If IsWindowVisible(CurhWnd) <> 0 Then
      Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_HIDEWINDOW Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE)
      Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_SHOWWINDOW Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE)
    End If
    PropertyChanged "UseBackground"
  End Property
  
  Public Property Get ShowDropArrows() As Boolean
Attribute ShowDropArrows.VB_Description = "Specifies how drop down button are displayed."
    ShowDropArrows = (SendMessage(CurhWnd, TB_GETEXTENDEDSTYLE, 0, ByVal 0) And TBSTYLE_EX_DRAWDDARROWS)
  End Property
  
  Public Property Let ShowDropArrows(NewValue As Boolean)
    Call ToolBar_ExStyleMod(CurhWnd, TBSTYLE_EX_DRAWDDARROWS, NewValue)
    Call ToolBar_Update(CurhWnd, CurRunMode)
    PropertyChanged "ShowDropArrows"
  End Property
#End If

Public Property Get Divider() As Boolean
Attribute Divider.VB_Description = "Specifies whether a divider is displayed on top of the toolbar."
  Divider = ((SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And CCS_NODIVIDER) = 0)
End Property

Public Property Let Divider(NewValue As Boolean)
  Call ToolBar_StyleMod(CurhWnd, CCS_NODIVIDER, Not NewValue)
  Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, (SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOACTIVATE Or SWP_FRAMECHANGED))
  PropertyChanged "Divider"
End Property

Public Property Get Ajustable() As TbrAjustableState
Attribute Ajustable.VB_Description = "Defines how and if the toolbar is adjustable."
Attribute Ajustable.VB_MemberFlags = "440"
  If SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And CCS_ADJUSTABLE Then
    Ajustable = IIf(SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And TBSTYLE_ALTDRAG, tbrAltDrag, tbrShiftDrag)
  Else
    Ajustable = tbrNotAjustable
  End If
End Property

Public Property Let Ajustable(NewValue As TbrAjustableState)
  #If DISALLOW_CUSTOMIZEPROP Then
    If NewValue <> tbrNotAjustable Then Error 383
  #End If
  Call ToolBar_StyleMod(CurhWnd, CCS_ADJUSTABLE, NewValue <> tbrNotAjustable)
  Call ToolBar_StyleMod(CurhWnd, TBSTYLE_ALTDRAG, NewValue = tbrAltDrag)
  Call ToolBar_Update(CurhWnd, CurRunMode)
  PropertyChanged "Ajustable"
End Property

'----------------------------------------------------------
' Chevron Handling!

Public Sub HandleChevron(ByVal hWndMenuBar As Long, ByVal AbsChevronLeft As Long, ByVal AbsChevronTop As Long, ByVal ChevronWidth As Long, ByVal ChevronHeight As Long, ByVal FirstInvisibleButton As Long, Optional ByVal BandBackground As IPicture, Optional ByVal ImageList As ImageListCore.ImageList)
Attribute HandleChevron.VB_Description = "Preforms a default reponse to the rebar's ChrvronPushed event."
  Dim I As Long
  Dim ID As Integer
  Dim CustomizeID As Integer
  Dim Button As ToolBarButton
  Dim ButtonStyles As TbrButtonStyles
  Dim ButtonStates As TbrButtonStates
  
  Dim mnuPopup As PopupMenus.MenuContainer
  Dim MenuItem As PopupMenus.MenuItem
  Dim MenuStyles As PopupMenus.MenuTypeFlags
  Dim MenuStates As PopupMenus.MenuStateFlags
  Dim NumButtons As Long
  
  If hWndMenuBar <> 0 Then
    If GetProp(hWndMenuBar, MBR_PROP_ISMENUBAR) = 0 Then Error 5
  End If
  Set mnuPopup = PopupMenus.CreateSubMenu()
  
  If FirstInvisibleButton Then
    If ImageList Is Nothing Then
      Set ImageList = Me.ImageList
    Else
      If Not TypeOf ImageList Is ImageListCore.ImageList Then Error 5
    End If
    NumButtons = SendMessage(CurhWnd, TB_BUTTONCOUNT, 0, ByVal 0)
    
    For I = FirstInvisibleButton - 1 To NumButtons - 1
      Set Button = ToolBar_GetItem(CurhWnd, I)
      ButtonStyles = Button.Style
      ButtonStates = Button.State
      MenuStates = 0             ' Reset.
      If hWndMenuBar Then
        MenuStyles = mnuFlagString Or mnuFlagDrawnByOwner
      Else
        MenuStyles = mnuFlagString
      End If
      If (ButtonStates And tbrStateHidden) = 0 And Not (((ButtonStyles And tbrStyleSeparator) = tbrStyleSeparator) And (MenuItem Is Nothing)) Then
        If (ButtonStyles And tbrStyleSeparator) = tbrStyleSeparator Then MenuStyles = MenuStyles Or mnuFlagSeparator
        If (ButtonStyles And tbrStyleGroup) = tbrStyleGroup Then MenuStyles = MenuStyles Or mnuFlagCheckRadio
        If (ButtonStates And tbrStateChecked) = tbrStateChecked Then MenuStates = MenuStates Or mnuStateChecked
        If ((ButtonStates And tbrStateEnabled) = 0) Then MenuStates = MenuStates Or mnuStateGrayed
#If (WIN32_IE >= IE4) Then
        If (ButtonStates And tbrStateMarked) = tbrStateMarked Then MenuStates = MenuStates Or mnuStateHilite
#End If
'       If (ButtonStates And tbrStateWrappedAfter) = tbrStateWrappedAfter Then MenuStyles = MenuStyles Or mnuFlagBreak
        Set MenuItem = mnuPopup.Menus.Add(Button.ID, Button.Caption, , , MenuStyles, MenuStates, , , , Button.SubMenu)
        MenuItem.DrawExtras.IconIndex(mnuImageNormal) = Button.ImageIndex
        MenuItem.DrawExtras.IconIndex(mnuImageChecked) = Button.ImageIndex
        MenuItem.DrawExtras.Metrics(mnuMtrIconWidth) = ImageList.IconWidth
        MenuItem.DrawExtras.Metrics(mnuMtrIconHeight) = ImageList.IconHeight
      End If
    Next
    Set MenuItem = mnuPopup.Menus.Add(, , , , mnuFlagSeparator Or mnuFlagDrawnByOwner)
  End If
  
  CustomizeID = mnuPopup.Menus.Add(, "Customize...", , , mnuFlagDrawnByOwner, IIf((SendMessage(CurhWnd, TB_GETSTYLE, 0, ByVal 0) And CCS_ADJUSTABLE) = 0, mnuStateGrayed, 0)).ID
  If Not BandBackground Is Nothing Then Set mnuPopup.DrawExtras.Background = BandBackground
  Set mnuPopup.DrawExtras.ImageLists(mnuImageNormal) = ImageList
  Set mnuPopup.DrawExtras.ImageLists(mnuImageChecked) = ImageList
  ID = mnuPopup.PopupEx(IIf(hWndMenuBar, hWndMenuBar, UserControl.hWnd), mnuPopupRightBtnClose Or mnuPopupReturnID, AbsChevronLeft, AbsChevronTop + ChevronHeight, AbsChevronLeft, AbsChevronTop, AbsChevronLeft + ChevronWidth, AbsChevronTop + ChevronHeight)
  If ID Then
    If ID = CustomizeID Then
      Call SendMessage(CurhWnd, TB_CUSTOMIZE, 0, ByVal 0)
    Else
      Call SendMessage(CurhWnd, WM_COMMAND, ID, ByVal CurhWnd)
    End If
  End If
    
  ' Kill/release the menu. The remove loop prevents the submenus from
  ' being destroyed when then the menu itsself is released.
  For I = mnuPopup.Menus.Count To 1 Step -1
    Call mnuPopup.Menus.Remove(I, mnuItemByPosition, False)
  Next
  Set mnuPopup = Nothing
End Sub


'===========================================================


'----------------------------------------------------------
' ToolBar Code

Private Sub ToolBar_Create(Optional ShowDropArrows As Boolean = True)
#If (WIN32_IE >= IE4) Then
  'CCS_ADJUSTABLE Or
  CurhWnd = CreateWindowEx(WS_EX_TOOLWINDOW, TOOLBARCLASSNAME, "Xception's controls  - VB5 [ToolBar]", WS_CHILD Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or CCS_NOPARENTALIGN Or CCS_NORESIZE Or CCS_NODIVIDER Or TBSTYLE_FLAT Or TBSTYLE_TOOLTIPS Or TBSTYLE_WRAPABLE Or TBSTYLE_TRANSPARENT, 0, 0, 2000, 22, UserControl.hWnd, 0, App.hInstance, Null)
#Else
  CurhWnd = CreateWindowEx(WS_EX_TOOLWINDOW, TOOLBARCLASSNAME, "Xception's controls  - VB5 [ToolBar]", WS_CHILD Or WS_CLIPCHILDREN Or WS_CLIPSIBLINGS Or CCS_NOPARENTALIGN Or CCS_NORESIZE Or CCS_NODIVIDER Or TBSTYLE_FLAT Or TBSTYLE_TOOLTIPS Or TBSTYLE_WRAPABLE, 0, 0, 2000, 22, UserControl.hWnd, 0, App.hInstance, Null)
#End If
  Set TB_Buttons = New ToolBarButtons
  Call TB_Buttons.Class_InitProps(CurhWnd)
  Dim TBBUTTON As TBBUTTON
  Call SendMessage(CurhWnd, TB_BUTTONSTRUCTSIZE, LenB(TBBUTTON), ByVal 0)
  Call SendMessage(CurhWnd, TB_SETPARENT, UserControl.hWnd, ByVal 0)
  Call SetProp(CurhWnd, RBR_PROP_MSG, UserControl.hWnd)
  Call SetProp(CurhWnd, TBR_PROP_BUTTONSCOL, -ObjPtr(TB_Buttons.Class_SaveCollection()))
  CurRunMode = UserControl.Ambient.UserMode
#If (WIN32_IE >= IE4) Then
  Me.ShowDropArrows = Me.ShowDropArrows
#End If
  Call Me.AutoSize
  If Not CurRunMode Then
    Dim StartPos As Long
    StartPos = Me.LoadButtonImageList(tbrIconStandardSmallColor)
    With TB_Buttons
      .Add , , "New", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFileNew
      .Add , , "Open", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFileOpen
      .Add , , "Close", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFileSave
      .Add , , , tbrStyleSeparator
      .Add , , "Print", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconPrint
      .Add , , "Preview", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconPrintPreview
      .Add , , , tbrStyleSeparator
      .Add , , "Cut", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconCut
      .Add , , "Copy", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconCopy
      .Add , , "Paste", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconPaste
      .Add , , "Delete", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconDelete
      .Add , , , tbrStyleSeparator
      .Add , , "Undo", tbrStyleAutoSize Or tbrStyleDropDown, , StartPos + TbrImageListsStandardIcons.tbrIconUndo
      .Add , , "Redo", tbrStyleAutoSize Or tbrStyleDropDown, , StartPos + TbrImageListsStandardIcons.tbrIconRedo
      .Add , , , tbrStyleSeparator
      .Add , , "Find", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconFind
      .Add , , "Replace", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconReplace
      .Add , , , tbrStyleSeparator
      .Add , , "Properties", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconProperties
      .Add , , "Help", tbrStyleAutoSize, , StartPos + TbrImageListsStandardIcons.tbrIconHelp
    End With
    Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_SHOWWINDOW)
  Else
    If True Or UserControl.Extender.Visible Then Call SetWindowPos(CurhWnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOSIZE Or SWP_SHOWWINDOW)
    EventHandler.Attached(UserControl.hWnd) = True
  End If
End Sub

Private Sub ToolBar_ClearUp()
  Dim I As Long
  Dim J As Long
  
  ' My first attempt to update the toolbar collection
  Debug.Print "TOOLBAR: CLEARUP!"
  
  ' Test my array here.
  I = 0
  Do While I < CurRemovedNum
    If SendMessage(CurhWnd, TB_GETSTATE, CurRemoved(I).idCommand, ByVal 0) <> -1 Then
      Debug.Print "CLEARING UP:    " & CurRemovedInfo(I)
      If I < (CurRemovedNum - 1) Then
        For J = I + 1 To CurRemovedNum - 1
          LSet CurRemoved(J - 1) = CurRemoved(J)
          CurRemovedInfo(J - 1) = CurRemovedInfo(J)
        Next
      End If
      CurRemovedNum = CurRemovedNum - 1
      I = I - 1
      If CurRemovedNum = 0 Then
        Erase CurRemoved
        Erase CurRemovedInfo
      Else
        ReDim Preserve CurRemoved(0 To CurRemovedNum - 1) As TBBUTTON
        ReDim Preserve CurRemovedInfo(0 To CurRemovedNum - 1) As String
      End If
    End If
    I = I + 1
  Loop
End Sub
